/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.contextRoot"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.BootstrapProperties"); //$NON-NLS-1$
	
	var DataCollectionConstants = com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants;
	
	DataCollectionConstants.ROOTSERVICESXML = net.jazz.ajax.contextRoot() + "/rootservices"; //$NON-NLS-1$
	DataCollectionConstants.HEADER_IF_MODIFIED_SINCE = "If-Modified-Since"; //$NON-NLS-1$
	DataCollectionConstants.HEADER_LASTMODIFIED = "Last-Modified"; //$NON-NLS-1$
	DataCollectionConstants.HEADER_ETAG = "Etag"; //$NON-NLS-1$
	DataCollectionConstants.HEADER_IF_MATCH = "If-Match"; //$NON-NLS-1$
	
	DataCollectionConstants.STATUS_NEW = "new"; //$NON-NLS-1$
	DataCollectionConstants.STATUS_DELETE = "delete"; //$NON-NLS-1$
	DataCollectionConstants.STATUS_UPDATE = "update"; //$NON-NLS-1$
	DataCollectionConstants.STATUS_IGNORE = "ignore"; //$NON-NLS-1$
	
	DataCollectionConstants.FORWARD_SLASH = "/"; //$NON-NLS-1$
	DataCollectionConstants.RESOURCE_GROUP_NAME = "ResourceGroupName"; //$NON-NLS-1$
	DataCollectionConstants.NS_TITLE = "http://purl.org/dc/terms/title"; //$NON-NLS-1$
	DataCollectionConstants.NS_RESOURCE_GROUP_TYPE = "http://jazz.net/ns/dcs#resourceGroupType"; //$NON-NLS-1$
	DataCollectionConstants.NS_BASE_URL = "http://jazz.net/ns/dcs#baseURL"; //$NON-NLS-1$
	DataCollectionConstants.NS_AUTH_TYPE = "http://jazz.net/ns/dcs#authenticationType"; //$NON-NLS-1$
	DataCollectionConstants.NS_USERNAME = "http://jazz.net/ns/dcs#username"; //$NON-NLS-1$
	DataCollectionConstants.NS_PASSWORD = "http://jazz.net/ns/dcs#password"; //$NON-NLS-1$
	DataCollectionConstants.NS_DB_TYPE = "http://jazz.net/ns/dcs#dbType"; //$NON-NLS-1$
	DataCollectionConstants.NS_ENABLED = "http://jazz.net/ns/dcs#enabled"; //$NON-NLS-1$
	DataCollectionConstants.NS_LOAD_TYPE = "http://jazz.net/ns/dcs#loadType"; //$NON-NLS-1$
	DataCollectionConstants.NS_AUTH_CONFIG = "http://jazz.net/ns/dcs#authenticationConfiguration"; //$NON-NLS-1$
	DataCollectionConstants.NS_BASE_RESOURCE_GROUP = "http://jazz.net/ns/dcs#baseResourceGroup"; //$NON-NLS-1$
	DataCollectionConstants.NS_RDF_TYPE = "http://www.w3.org/1999/02/22-rdf-syntax-ns#type"; //$NON-NLS-1$
	DataCollectionConstants.NS_SUPPORT_QUERY = "http://jazz.net/ns/dcs#supportQuery"; //$NON-NLS-1$
	DataCollectionConstants.NS_PARAMETER = "http://jazz.net/ns/dcs#parameter"; //$NON-NLS-1$
	DataCollectionConstants.NS_NAME = "http://jazz.net/ns/dcs#name"; //$NON-NLS-1$
	DataCollectionConstants.NS_LOCAL_TRANSFORM = "http://jazz.net/ns/dcs#localTransform"; //$NON-NLS-1$
	DataCollectionConstants.NS_VALUE = "http://jazz.net/ns/dcs#value"; //$NON-NLS-1$
	DataCollectionConstants.NS_VERSION = "http://jazz.net/ns/dcs#version"; //$NON-NLS-1$
	DataCollectionConstants.NS_INTERVAL_SCHEDULE = "http://jazz.net/ns/dcs/schedule#IntervalRecurringSchedule"; //$NON-NLS-1$
	DataCollectionConstants.NS_DAILY_SCHEDULE = "http://jazz.net/ns/dcs/schedule#DayTimesRecurringSchedule"; //$NON-NLS-1$
	
	DataCollectionConstants.TRUE = "true"; //$NON-NLS-1$
	DataCollectionConstants.FALSE = "false"; //$NON-NLS-1$
	
	DataCollectionConstants.FULL_LOAD = "F"; //$NON-NLS-1$
	DataCollectionConstants.DELTA_LOAD = "D"; //$NON-NLS-1$
	
	DataCollectionConstants.RUNNING = "running"; //$NON-NLS-1$
	DataCollectionConstants.STOPPING = "stopping"; //$NON-NLS-1$
	DataCollectionConstants.IDLE = "idle"; //$NON-NLS-1$
	
	DataCollectionConstants.APPID_JTS = "http://jazz.net/application/jts"; //$NON-NLS-1$
	DataCollectionConstants.APPID_CCM = "http://jazz.net/application/ccm"; //$NON-NLS-1$
	DataCollectionConstants.APPID_QM = "http://jazz.net/application/qm"; //$NON-NLS-1$
	DataCollectionConstants.APPID_RM = "http://jazz.net/application/rm"; //$NON-NLS-1$
	DataCollectionConstants.APPID_CUSTOM = "http://jazz.net/application/custom"; //$NON-NLS-1$
	DataCollectionConstants.APPID_RDB = "http://jazz.net/application/rdb"; //$NON-NLS-1$
	
	DataCollectionConstants.JTS_RESOURCE_GROUP_NAME = "JFSResourceGroup"; //$NON-NLS-1$
	DataCollectionConstants.CCM_RESOURCE_GROUP_NAME = "RTCResourceGroup"; //$NON-NLS-1$
	DataCollectionConstants.QM_RESOURCE_GROUP_NAME = "RQMResourceGroup"; //$NON-NLS-1$
	DataCollectionConstants.RM_RESOURCE_GROUP_NAME = "RRCResourceGroup"; //$NON-NLS-1$
	DataCollectionConstants.CUSTOM_RESOURCE_GROUP_NAME = "CustomResourceGroup"; //$NON-NLS-1$
	DataCollectionConstants.RDB_RESOURCE_GROUP_NAME = "RDBResourceGroup"; //$NON-NLS-1$
	
	DataCollectionConstants.JTS_BASE_RESOURCE_GROUP_NAME = "JFSBaseResourceGroup"; //$NON-NLS-1$
	DataCollectionConstants.CCM_BASE_RESOURCE_GROUP_NAME = "RTCBaseResourceGroup"; //$NON-NLS-1$
	DataCollectionConstants.QM_BASE_RESOURCE_GROUP_NAME = "RQMBaseResourceGroup"; //$NON-NLS-1$
	DataCollectionConstants.RM_BASE_RESOURCE_GROUP_NAME = "RRCBaseResourceGroup"; //$NON-NLS-1$
	DataCollectionConstants.CUSTOM_BASE_RESOURCE_GROUP_NAME = "CustomBaseResourceGroup"; //$NON-NLS-1$
	DataCollectionConstants.RDB_BASE_RESOURCE_GROUP_NAME = "RDBBaseResourceGroup"; //$NON-NLS-1$
	
	DataCollectionConstants.AUTH_TYPE_BASIC_NAME = "Username and Password"; //$NON-NLS-1$
	DataCollectionConstants.AUTH_TYPE_JFS_NAME = "OAuth-JTS"; //$NON-NLS-1$
	DataCollectionConstants.AUTH_TYPE_JDBC_NAME = "JDBC"; //$NON-NLS-1$
	DataCollectionConstants.PARAMETER_TYPE_VALUE_NAME = "Value"; //$NON-NLS-1$
	DataCollectionConstants.PARAMETER_TYPE_LOCAL_TRANSFORM_NAME = "LocalTransform"; //$NON-NLS-1$
		
	DataCollectionConstants.AUTH_TYPE_BASIC_VALUE = "http://jazz.net/ns/dcs#BasicAuthentication"; //$NON-NLS-1$
	DataCollectionConstants.AUTH_TYPE_JFS_VALUE = "http://jazz.net/ns/dcs#JFSAuthentication"; //$NON-NLS-1$
	DataCollectionConstants.AUTH_TYPE_JDBC_VALUE = "http://jazz.net/ns/dcs#JDBCAuthentication"; //$NON-NLS-1$
	
	DataCollectionConstants.DB_TYPE_DB2_NAME = "DB2"; //$NON-NLS-1$
	DataCollectionConstants.DB_TYPE_ORACLE_NAME = "Oracle"; //$NON-NLS-1$
	DataCollectionConstants.DB_TYPE_SQLSERVER_NAME = "SQL Server"; //$NON-NLS-1$
	DataCollectionConstants.DB_TYPE_DERBY_CLIENT_NAME = "Derby Client"; //$NON-NLS-1$
	DataCollectionConstants.DB_TYPE_DB2_VALUE = "http://jazz.net/ns/dcs#DB2"; //$NON-NLS-1$
	DataCollectionConstants.DB_TYPE_ORACLE_VALUE = "http://jazz.net/ns/dcs#Oracle"; //$NON-NLS-1$
	DataCollectionConstants.DB_TYPE_SQLSERVER_VALUE = "http://jazz.net/ns/dcs#SQLServer"; //$NON-NLS-1$
	DataCollectionConstants.DB_TYPE_DERBY_CLIENT_VALUE = "http://jazz.net/ns/dcs#DerbyClient"; //$NON-NLS-1$
	
	
	DataCollectionConstants.RCS_GROUP_TYPE_DATASERVICE_VALUE = "http://jazz.net/ns/dcs#DataService"; //$NON-NLS-1$
	DataCollectionConstants.RCS_GROUP_TYPE_RDF_VALUE = "http://jazz.net/ns/dcs#RDF"; //$NON-NLS-1$
	DataCollectionConstants.RCS_GROUP_TYPE_DB_VALUE = "http://jazz.net/ns/dcs#RDB"; //$NON-NLS-1$	
	
	DataCollectionConstants.VERSION_50_NAME = "5.0"; //$NON-NLS-1$
	
	DataCollectionConstants.VERSION_50_VALUE = "5.0"; //$NON-NLS-1$
})();
