/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.rational.datacollection.web.ui.internal.editors.BaseResourceGroupSection"); //$NON-NLS-1$
	dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$
	dojo.require("jazz.ui.Menu"); //$NON-NLS-1$
	dojo.require("dojox.uuid.generateTimeBasedUuid"); //$NON-NLS-1$
	dojo.require("dojox.uuid.Uuid"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.Section"); //$NON-NLS-1$
	dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.ResourceGroupSection"); //$NON-NLS-1$
	dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	var Section = com.ibm.rational.datacollection.web.ui.internal.editors.Section;
	var ResourceGroupSection = com.ibm.rational.datacollection.web.ui.internal.editors.ResourceGroupSection;
	var DataCollectionConstants = com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants;
	var TITLE_TEMPLATE = "${0} (${1})"; //$NON-NLS-1$
	dojo.declare("com.ibm.rational.datacollection.web.ui.internal.editors.BaseResourceGroupSection", Section, { //$NON-NLS-1$				
		data: null,
		controller: null,
		resourceGroupSections: null,
		constructor: function(args) {
			this.resourceGroupSections = [];
		},
		
		postCreate: function() {
			this.inherited(arguments);
			
			if (this.data["dcterms:identifier"] === DataCollectionConstants.APPID_RDB) {
				dojo.toggleClass(this._addLink, "hide", true);
			}			
		},
		
		getTitle: function() {
			var title = this.data["dcterms:title"]; //$NON-NLS-1$ 
			return title
		},
		
		isRM: function() {
			return  this.data["dcterms:identifier"] === DataCollectionConstants.APPID_RM; //$NON-NLS-1$ 
		},
		
		getWorkingCopy: function() {
			return this.controller.getWorkingCopy();
		},
		
		onAdd: function() {
			var workingCopy = this.getWorkingCopy();
			var item = workingCopy.createResourceGroup(this.data["uri"]); //$NON-NLS-1$
			this.addItem(item);
		},
		
		addItem: function(item) {
			var resourceGroupSection = new ResourceGroupSection({
				controller: this,
				data: item,
				identifier: this.data["dcterms:identifier"] //$NON-NLS-1$
			});
			resourceGroupSection.toggleEditMode(true);
			this.resourceGroupSections.push(resourceGroupSection);
			this.contentArea.appendChild(resourceGroupSection.domNode);
			this.setChange();
			this.layoutSections(resourceGroupSection);
		},
		
		removeItem: function(item) {
			this.resourceGroupSections.splice(dojo.indexOf(this.resourceGroupSections, item), 1);
			item.destroyRecursive();
			this.setChange();
		},
		
		setChange: function() {
			this.controller.setChange();
		},
		
		_onCollapseButtonClick: function(evt) {
			this.inherited(arguments);
			this.controller.layoutSections(this);
		},
		
		layoutSections: function(section){
			this.controller.layoutSections(section);
		},
		
		uninitialize: function() {
			for (var i = 0; i < this.resourceGroupSections.length; i++) {
				this.resourceGroupSections[i].destroyRecursive();
			}
			this.inherited(arguments);
		}
	});
	
})();
