/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.rational.datacollection.web.ui.internal.editors.ConfigureDeltaLoad"); //$NON-NLS-1$

dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionClient"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.ResourceHelper");//$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.AbstractEditor"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.CancellableCalendar"); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$
dojo.require("jazz.ui.underlay"); //$NON-NLS-1$
dojo.require("jazz.ui.StyledTable"); //$NON-NLS-1$
dojo.require("jazz.app.ua.PageHoverHelp"); //$NON-NLS-1$
dojo.require("dijit.form.DateTextBox"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.date.locale"); //$NON-NLS-1$
dojo.require("jazz.app.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "ConfigureDeltaLoadMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	
var DataCollectionClient = com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionClient;
var DataCollectionConstants = com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants;
var ResourceHelper = com.ibm.rational.datacollection.web.ui.internal.common.ResourceHelper;
var AbstractEditor = com.ibm.rational.datacollection.web.ui.internal.editors.AbstractEditor;
var PageHoverHelp = jazz.app.ua.PageHoverHelp;
var DateTextBox = dijit.form.DateTextBox;
var CancellableCalendar = com.ibm.rational.datacollection.web.ui.internal.editors.CancellableCalendar;

dojo.declare("com.ibm.rational.datacollection.web.ui.internal.editors.ConfigureDeltaLoad", [AbstractEditor], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.rational.datacollection.web", "ui/internal/editors/templates/ConfigureDeltaLoad.html"), //$NON-NLS-1$ //$NON-NLS-2$
	resourceGroupTable: null,
	items: null,
	_enableAllControl: null,
	_allCheckboxes: [],
	// widget initialization
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "ConfigureDeltaLoadMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	postCreate: function () {
		this.inherited(arguments);
		
		this._allCheckboxes = [];
		this._enableAllControl = null;
		this._createTable();
		this.refresh();
		this.connect(this._saveButton, "onclick", function(e) { //$NON-NLS-1$
			jazz.ui.underlay.show();
			var data = this.getUpdateItems();
			DataCollectionClient.updateDeltaLoadConfiguration({
				data: data,
				load: dojo.hitch(this, function(data, ioArgs) {
					this.refresh();
				}),
				error: dojo.hitch(this, function(error, ioArgs) {
					this.displayDetailedErrorMessage(this.messages.updateDeltaLoadConfigurationFailed, error);
					jazz.ui.underlay.hide();
				})
			});
		});
		
		// Add the page hover description
		this._pageHelpHover = new PageHoverHelp({ contentString: this.messages.pageHoverHelpDescription });
		this.helpHover.appendChild(this._pageHelpHover.domNode);
	},
	
	_createTable: function() {
		var enabledHeaderContainer = document.createElement("div"); //$NON-NLS-1$
		
		this._enableAllControl = document.createElement("input"); //$NON-NLS-1$
		this._enableAllControl.type = "checkbox"; //$NON-NLS-1$
		this._enableAllControl.style.padding = "4px"; //$NON-NLS-1$
		this._enableAllControl.style.width = "auto"; //$NON-NLS-1$
		dojo.connect(this._enableAllControl, "onclick", this, function(e) { //$NON-NLS-1$
			for (var i = 0; i < this._allCheckboxes.length; i++) {
				this.items[i]["dcs:enabled"] = this._enableAllControl.checked ? DataCollectionConstants.TRUE : DataCollectionConstants.FALSE; //$NON-NLS-1$
				this.items[i].status = DataCollectionConstants.STATUS_UPDATE;
				this._allCheckboxes[i].checked = this._enableAllControl.checked;
			}
			this._updateSelectAll();
			this.setChange();
		});

		enabledHeaderContainer.appendChild(this._enableAllControl)
		
		var labelElement = document.createElement("label"); //$NON-NLS-1$
		labelElement.innerHTML = this.messages.enabled;
		
		enabledHeaderContainer.appendChild(labelElement);
		
		this.resourceGroupTable = new jazz.ui.StyledTable({
			columns : [ {
				label : enabledHeaderContainer,
				sortable : false,
				width : "5%" //$NON-NLS-1$
			}, {
				label : this.messages.resourceGroupId,
				sortable : false,
				width : "20%" //$NON-NLS-1$
			}, {
				label : this.messages.baseURL,
				sortable : false,
				width : "300px" //$NON-NLS-1$
			}, {
				label : this.messages.loadType,
				sortable : false,
				width : "25%" //$NON-NLS-1$
			}],
			sortBy : 2,
			sortByAscending : false,
			handleSort : function() {
			},
			trim : jazz.ui.styledTable.TrimStyles.BLUE
		});
		
		this.resourceGroupTable.domNode.style.width = "100%"; //$NON-NLS-1$
		this.contentArea.appendChild(this.resourceGroupTable.domNode);
	},
	
	_initializeContent: function () {
		this._allCheckboxes = [];
		DataCollectionClient.getResourceGroupCollection({
			load: dojo.hitch(this, function(data, ioArgs) {
				for (var i = 0; i < data.length; i++) {
					var item = data[i];
					this.items.push(item);
					this.addRow(item);
				}
				this._updateSelectAll();
				this.onLoadingComplete();
			}),
			error: dojo.hitch(this, function(error, ioArgs) {
				this.displayDetailedErrorMessage(this.messages.fetchFailed, error);
				jazz.ui.underlay.hide();
			})
		});
	},
	
	addRow: function(item) {
		var row, enabled, resourceGroupId, baseURL, loadType;
		var _self = this;
		var isRDBResourceGroup = item["dcs:baseResourceGroup"].indexOf(DataCollectionConstants.RDB_BASE_RESOURCE_GROUP_NAME) !== -1; //$NON-NLS-1$
		row = document.createElement("tr"); //$NON-NLS-1$

		enabled = document.createElement("td"); //$NON-NLS-1$
		resourceGroupId = document.createElement("td"); //$NON-NLS-1$
		loadType = document.createElement("td"); //$NON-NLS-1$
		baseURL = document.createElement("td"); //$NON-NLS-1$
		
		dojo.addClass(enabled, "center-column"); //$NON-NLS-1$
		var enabledInput = document.createElement("input"); //$NON-NLS-1$
		enabledInput.type = "checkbox"; //$NON-NLS-1$
		enabled.appendChild(enabledInput);
		enabledInput.checked = (item["dcs:enabled"] === DataCollectionConstants.TRUE); //$NON-NLS-1$
		this._allCheckboxes.push(enabledInput);
		item["dcs:enabled"] = null; //$NON-NLS-1$
		enabledInput.item = item;
		enabledInput.disabled = item.currentlyRunning == true;
		dojo.connect(enabledInput, "onclick", this, function(e) { //$NON-NLS-1$
			var target = this._getCurrentTarget(e);
			target.item["dcs:enabled"] = target.checked ? DataCollectionConstants.TRUE : DataCollectionConstants.FALSE; //$NON-NLS-1$
			target.item.status = DataCollectionConstants.STATUS_UPDATE;
			this._updateSelectAll();
			this.setChange();
		});
		resourceGroupId.innerHTML = item["dcterms:title"]; //$NON-NLS-1$
		baseURL.innerHTML = item["dcs:baseURL"]; //$NON-NLS-1$
		
		if (!isRDBResourceGroup) {
			dojo.addClass(loadType, "center-column"); //$NON-NLS-1$
			var loadTypeSelect = document.createElement("select"); //$NON-NLS-1$
			loadTypeSelect.item = item;
			loadType.appendChild(loadTypeSelect);
			
			//populate options
			var option = document.createElement("option"); //$NON-NLS-1$
			option.text = this.messages.fullLoad;				
			option.value = "F"; //$NON-NLS-1$
			loadTypeSelect.options[loadTypeSelect.options.length] = option;
			
			option = document.createElement("option"); //$NON-NLS-1$
			option.text = this.messages.deltaLoadSincePrev;
			option.value = "D"; //$NON-NLS-1$
			loadTypeSelect.options[loadTypeSelect.options.length] = option;
			
			option = document.createElement("option"); //$NON-NLS-1$
			option.text = this.messages.deltaLoadSinceDate;
			option.value = "M"; //$NON-NLS-1$
			loadTypeSelect.options[loadTypeSelect.options.length] = option;
			
			if ( item["dcs:modifiedSince"] ) {
			    option = document.createElement("option"); //$NON-NLS-1$
				option.text = dojo.string.substitute(this.messages.deltaLoadSince, [item["dcs:modifiedSince"]]); 
				option.value = "S"; //$NON-NLS-1$
				loadTypeSelect.options[loadTypeSelect.options.length] = option;
				option.modifiedSince = item["dcs:modifiedSince"];
			} 
			
			//make default selection
			loadTypeSelect.selectedIndex = -1;
			if ( item["dcs:loadType"] === DataCollectionConstants.FULL_LOAD ) {
				loadTypeSelect.selectedIndex = 0;
			} else if ( item["dcs:modifiedSince"] ) {
			    loadTypeSelect.selectedIndex = loadTypeSelect.options.length-1;
			} else {
				loadTypeSelect.selectedIndex = 1;
			}
			
			//handle runtime selection
			var prevSelection = loadTypeSelect.selectedIndex;
		    dojo.connect(loadTypeSelect, "onchange", this, function(e) { //$NON-NLS-1$
		    	var target = this._getCurrentTarget(e);
				if (target.value === "M") {
					var dropDown = new CancellableCalendar({
				        value: new jazz.app.i18n.Date(),
				        datePackage: jazz.app.i18n.datePackage
				    });
				    dijit.popup.open({
    					parent: this,
   						popup: dropDown,
    					around: loadTypeSelect,
   						orient: {'BR':'TR', 'BL':'TL', 'TR':'BR', 'TL':'BL'},
  					  	onExecute: dojo.hitch(this, function(){ 
  					  	     //create a new selection
  					  	     option = document.createElement("option"); //$NON-NLS-1$
  					  	     var date = dropDown.get('value'); //$NON-NLS-1$
  					  	     
  					  	
  					  	     if(dojo.i18n.normalizeLocale() == "en-us") {
  					  	    	 item["dcs:modifiedSince"] = dojo.date.locale.format(date, {datePattern : "yyyy-MM-dd", selector :'date'}); //$NON-NLS-1$
  					  	     }else{
  					  	    	 item["dcs:modifiedSince"] = dojo.date.locale.format(date, {selector :'date'}); //$NON-NLS-1$
  					  	     }
  					  	  			  	    
							 option.text = dojo.string.substitute(this.messages.deltaLoadSince, [item["dcs:modifiedSince"]]); 
							 option.value = "S"; //$NON-NLS-1$
							 loadTypeSelect.options[loadTypeSelect.options.length] = option;
							 option.modifiedSince = item["dcs:modifiedSince"];
							 //set it as selected
							 loadTypeSelect.selectedIndex = loadTypeSelect.options.length-1;
							
							 target.item["dcs:loadType"] = DataCollectionConstants.DELTA_LOAD; 
							 prevSelection = target.selectedIndex;		
							 dijit.popup.close(dropDown);
   						 }),
   					 	onCancel: function(){
   					 		target.selectedIndex = prevSelection;
   					 		dijit.popup.close(dropDown);
    					},
    					onClose: function(){
    					}					    
    				});
					
				} else if ( target.value === "S") {
					item["dcs:modifiedSince"] = target.options[target.selectedIndex].modifiedSince;
					target.item["dcs:loadType"] = DataCollectionConstants.DELTA_LOAD; 
					prevSelection = target.selectedIndex;
				} else if ( target.value === "F") {
					item["dcs:modifiedSince"] = null;
					target.item["dcs:loadType"] = DataCollectionConstants.FULL_LOAD; 
					prevSelection = target.selectedIndex;
				} else {
					item["dcs:modifiedSince"] = null;
					target.item["dcs:loadType"] = DataCollectionConstants.DELTA_LOAD; 
					prevSelection = target.selectedIndex;
				}
				target.item.status = DataCollectionConstants.STATUS_UPDATE;
				this.setChange();
			});
		}
		
		row.appendChild(enabled);
		row.appendChild(resourceGroupId);
		row.appendChild(baseURL);
		
		row.appendChild(loadType);
		
		this.resourceGroupTable.tbody.appendChild(row);
	},
	
	onLoadingComplete: function () {
		this.hideMessage();
		jazz.ui.underlay.hide();
	},
	
	setChange: function() {
		this._saveButton.disabled = false;
	},
	
	getUpdateItems: function() {
		var updateItems = [];
		for (var i = 0; i < this.items.length; i++) {
			if (this.items[i].status === DataCollectionConstants.STATUS_UPDATE) {
				var item = {};
				item["uri"] = this.items[i]["uri"]; //$NON-NLS-1$ //$NON-NLS-2$
				item["dcs:loadType"] = this.items[i]["dcs:loadType"] ? this.items[i]["dcs:loadType"] : null; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				item["dcs:enabled"] = this.items[i]["dcs:enabled"]; //$NON-NLS-1$ //$NON-NLS-2$
				item["etag"] = this.items[i]["etag"]; //$NON-NLS-1$ //$NON-NLS-2$
				if (this.items[i]["dcs:modifiedSince"]) { //$NON-NLS-1$
					item["dcs:modifiedSince"] = this.items[i]["dcs:modifiedSince"]; //$NON-NLS-1$ //$NON-NLS-2$
				}
				updateItems.push(item);
			}
		}
		
		return updateItems;
	},
	
	refresh: function() {
		this.hideMessage();
		this.displayInfoMessage(this.messages.loading);
		this.items = [];
		this._saveButton.disabled = true;
		jazz.ui.underlay.show();
		dojo.empty(this.resourceGroupTable.tbody);
		
		// Update select all
		this._allCheckboxes = [];
		this._updateSelectAll();
		
		// fetch and build contents
		this._initializeContent();
	},
	
	uninitialize: function(){
		this.inherited(arguments);
	},
	
	_updateSelectAll: function() {
		var selectedCount = 0;
		for (var i = 0; i < this._allCheckboxes.length; i++) {
			if (this._allCheckboxes[i].checked) {
				selectedCount++;
			}
		}
		if (selectedCount === 0) {
			this._enableAllControl.indeterminate = false;
			this._enableAllControl.checked = false;
		} else if (this._allCheckboxes.length === selectedCount) {
			this._enableAllControl.indeterminate = false;
			this._enableAllControl.checked = true;
		} else {
			this._enableAllControl.indeterminate = true;
		}
	}
});

})();