/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2013,
 * 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.datacollection.web.ui.internal.editors.ConfigureETLJob"); //$NON-NLS-1$

dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionClient"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.Toolbar"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.AbstractEditor"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.ValidatingTextBox"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.ScheduleDialog"); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$
dojo.require("jazz.ui.underlay"); //$NON-NLS-1$
dojo.require("jazz.ui.StyledTable"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
dojo.require("jazz.app.ua.PageHoverHelp"); //$NON-NLS-1$
dojo.require("dojox.html.entities"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "ConfigureETLJobMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	
var DataCollectionClient = com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionClient;
var DataCollectionConstants = com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants;
var Toolbar = com.ibm.rational.datacollection.web.ui.internal.common.Toolbar;
var AbstractEditor = com.ibm.rational.datacollection.web.ui.internal.editors.AbstractEditor;
var PageHoverHelp = jazz.app.ua.PageHoverHelp;
var ValidatingTextBox = com.ibm.rational.datacollection.web.ui.internal.editors.ValidatingTextBox;
var ScheduleDialog = com.ibm.rational.datacollection.web.ui.internal.editors.ScheduleDialog;
var MessageBox = jazz.ui.MessageBox;


// refresh available jobs and their status every 20 seconds
var REFRESH_RATE = 20 * 1000;

var ODS = "ods"; //$NON-NLS-1$
var DATA_MART = "data-mart"; //$NON-NLS-1$
var LICENSES = "licenses"; //$NON-NLS-1$

var ODS_JOBS = {

	"APT": true, //$NON-NLS-1$
	"JFS_ODS": true, //$NON-NLS-1$
	"JFS_Repository": true, //$NON-NLS-1$
	"RQM_ODS": true, //$NON-NLS-1$
	"RRC_ODS": true, //$NON-NLS-1$
	"RTC_Build": true, //$NON-NLS-1$
	"RTC_SCM_ODS": true, //$NON-NLS-1$
	"RTC_Workitem": true, //$NON-NLS-1$	
	"Timesheet_ODS": true, //$NON-NLS-1$
	"Timesheet_ODSDB": true, //$NON-NLS-1$
	"Timesheet_ODSDB2":true, //$NON-NLS-1$
	"CQ_STG_DB_HISTORY": true, //$NON-NLS-1$
	"CQ_STG_DB_AUH": true, //$NON-NLS-1$
	"CQ_STG_DB_STATE": true, //$NON-NLS-1$
	"CQ_STG": true, //$NON-NLS-1$
	"CQ_STG_COMMON": true, //$NON-NLS-1$
};

var DATAMART_JOBS = {
	"DeleteFact": true, //$NON-NLS-1$
	"Dimension": true, //$NON-NLS-1$
	"Fact_Activity": true, //$NON-NLS-1$
	"Fact_Build": true, //$NON-NLS-1$
	"Fact_File": true, //$NON-NLS-1$
	"Fact_PM": true, //$NON-NLS-1$
	"Fact_QM": true, //$NON-NLS-1$
	"Fact_RM": true, //$NON-NLS-1$
	"Fact_Request": true, //$NON-NLS-1$
	"Fact_Task": true, //$NON-NLS-1$
	"History_Activity": true, //$NON-NLS-1$
	"History_Build": true, //$NON-NLS-1$
	"History_File": true, //$NON-NLS-1$
	"History_PM": true, //$NON-NLS-1$
	"History_QM": true, //$NON-NLS-1$
	"History_Request": true, //$NON-NLS-1$
	"History_RM": true, //$NON-NLS-1$
	"History_Task": true, //$NON-NLS-1$
	"ProjectArea_ODS": true, //$NON-NLS-1$
	"RTC_SCM_DIMENSION": true, //$NON-NLS-1$
	"RTC_SCM_FACT": true, //$NON-NLS-1$
	"WORKITEM_ODS_DB": true, //$NON-NLS-1$
};

var LICENSES_JOBS = {
	"JFS_License": true, //$NON-NLS-1$		
};

dojo.declare("com.ibm.rational.datacollection.web.ui.internal.editors.ConfigureETLJob", [AbstractEditor], { //$NON-NLS-1$
	templatePath: dojo.moduleUrl("com.ibm.rational.datacollection.web", "ui/internal/editors/templates/ConfigureETLJob.html"), //$NON-NLS-1$ //$NON-NLS-2$
	odsCollection: null,
	datamartCollection: null,
	licensesCollection: null,
	odsTable: null,
	datamartTable: null,
	licensesTable: null,
	items: {},
	isDirty: false,
	availableItems: {},
	
	_timer: null,
	
	_licensesSchedule: null,
	_datamartSchedule: null,
	_odsSchedule: null,
	
	_isDccEnabled: false, // whether or not DCC is currently enabled
	
	// widget initialization
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "ConfigureETLJobMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.runAllIconSrc = dojo.moduleUrl("com.ibm.rational.datacollection.web","graphics/icons/run-etl-job_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	postCreate: function () {
		this.inherited(arguments);
		
		this.odsTable = this._createTable();
		this.odsContentArea.appendChild(this.odsTable.domNode);
		this.datamartTable = this._createTable();
		this.datamartContentArea.appendChild(this.datamartTable.domNode);
		this.licensesTable = this._createTable();
		this.licensesContentArea.appendChild(this.licensesTable.domNode);
		this.refresh();
		
		
		
		this.connect(this._saveButton, "onclick", function(e) { //$NON-NLS-1$
			this._save();
		});
		
		this.connect(this._selectButton, "onclick", function(e) { //$NON-NLS-1$
			for(var id in this.items) {
				if (this.availableItems[id]) {
					this.enableBoxes[this.items[id].name].checked = true;
					this.items[id].status = DataCollectionConstants.STATUS_UPDATE;
					this.items[id].enabled = DataCollectionConstants.TRUE;
					this.setChange();
				}
			}
		});
		
		this.connect(this._enableDccCheckBox, "onclick", function(e){
			this.setChange();			
		});
		
		this.connect(this._runAllJobsLink, "onclick", this._handleRunAllJobs); //$NON-NLS-1$
		
		// Add the page hover description
		this._pageHelpHover = new PageHoverHelp({ contentString: this.messages.pageHoverHelpDescription });
		this.helpHover.appendChild(this._pageHelpHover.domNode);

		// determine if DCC is enabled before loading the rest of the page
		DataCollectionClient.getDccEnabled({
			load: dojo.hitch(this, function(data, ioArgs) {
				var enabled = data["value"];
				if (enabled === "true") {
					this._enableDataCollection();
				} else {
					this._disableDataCollection();
				}
				this.refresh();
			}),
			error: dojo.hitch(this, function(error, ioArgs) {
				this.displayDetailedErrorMessage(this.messages.checkDCCEnabledFailed, error);
			})			
		});
	},
	
	
	_updateWarningMessage: function(){
		var waringmessage=this.messages.etlWarningForResourceGroup;
		for (var id in ODS_JOBS) {
			var item = this.items[id];
			if (item && this.availableItems[id]) {
				if (item.enabled === DataCollectionConstants.TRUE) {
					waringmessage=this.messages.etlWarningForClm;
					break;
				}
			}
		}	
		var warning = new MessageBox();
		warning.showMessage({
			type: MessageBox.STATUS_TYPES.WARNING,
			summary: waringmessage,
		});
		
		warning.messageArea.style = "border-radius: 0px;"; //$NON-NLS-1$
		dojo.empty(this._warningContainer);
		this._warningContainer.appendChild(warning.domNode);
	},
	/**
	 * Disable page controls to prevent user from making changes/requesting jobs
	 * while DCC is not enabled.
	 */
	_disableDataCollection: function() {
		this._enableDccCheckBox.checked = false;
		this._isDccEnabled = false;
		
		// hide "run all jobs" link
		dojo.addClass(this._runAllJobsDiv, "hidden");
	},
	
	/**
	 * Enable page controls when DCC is enabled.
	 */
	_enableDataCollection: function() {
		this._enableDccCheckBox.checked = true;
		this._isDccEnabled = true;		
		
		// show the "run all jobs" link
		dojo.removeClass(this._runAllJobsDiv, "hidden");
	},
	
	_createTable: function() {
		var table = new jazz.ui.StyledTable({
			columns : [ {
				label : this.messages.enabled,
				sortable : false,
				width : "5%" //$NON-NLS-1$
			}, {
				label : this.messages.dataCollectionJob,
				sortable : false,
				width : "300px" //$NON-NLS-1$
			}, {
				label : this.messages.state,
				sortable : false,
				width : "7%" //$NON-NLS-1$
			}, {
				label : this.messages.actions,
				sortable : false,
				width : "5%" //$NON-NLS-1$
			} ],
			sortBy : 2,
			sortByAscending : false,
			handleSort : function() {
			},
		});
		
		table.domNode.style.width = "100%"; //$NON-NLS-1$
		return table;
	},
	
	_save: function() {
		this.displayInfoMessage(this.messages.saving);
		
		var deferreds = [];
		if (this.isDirty) {
			deferreds.push(DataCollectionClient.updateMapGroupCollection({
				data: this.getUpdateItems(),
				load: function(data, ioArgs) {
				},
				error: dojo.hitch(this, function(error, ioArgs) {
					this.displayDetailedErrorMessage(this.messages.updateMapgroupFailed, error);
				})
			}));
			
			var newEnableValue = this._enableDccCheckBox.checked;
			if (newEnableValue !== this._isDccEnabled) {
				deferreds.push(DataCollectionClient.setDccEnabled({				
					value: newEnableValue,
					load: dojo.hitch(this, function(data, ioArgs) {
						// enable/disable the page as required
						if (newEnableValue) {
							this._enableDataCollection();
						} else {
							this._disableDataCollection();
						}
					}),
					error: dojo.hitch(this, function(error, ioArgs) {
						this.displayDetailedErrorMessage(this.messages.enableDCCFailed, error);
					})
				}));
			}
		}
		
		if (this.odsCollection && this._odsSchedule !== this.odsCollection.schedule) {
			var workingCopy = dojo.mixin({}, this.odsCollection);
			if (this._odsSchedule) {
				workingCopy.schedule = this._odsSchedule;
			} else {
				delete workingCopy.schedule;
			}
			delete workingCopy.nextTime;
			deferreds.push(DataCollectionClient.modifyScheduledTask({
				id: ODS,
				data: workingCopy,
				error: dojo.hitch(this, function(error, ioArgs) {
					this.displayDetailedErrorMessage(this.messages.failedSavingOds, error);
				})
			}));
		}

		if (this.datamartCollection && this._datamartSchedule !== this.datamartCollection.schedule) {
			var workingCopy = dojo.mixin({}, this.datamartCollection);
			if (this._datamartSchedule) {
				workingCopy.schedule = this._datamartSchedule;
			} else {
				delete workingCopy.schedule;
			}
			delete workingCopy.nextTime;
			deferreds.push(DataCollectionClient.modifyScheduledTask({
				id: DATA_MART,
				data: workingCopy,
				error: dojo.hitch(this, function(error, ioArgs) {
					this.displayDetailedErrorMessage(this.messages.failedSavingDatamart, error);
				})
			}));
		}

		if (this.licensesCollection && this._licensesSchedule !== this.licensesCollection.schedule) {
			var workingCopy = dojo.mixin({}, this.licensesCollection);
			if (this._licensesSchedule) {
				workingCopy.schedule = this._licensesSchedule;
			} else {
				delete workingCopy.schedule;
			}
			delete workingCopy.nextTime;
			deferreds.push(DataCollectionClient.modifyScheduledTask({
				id: LICENSES,
				data: workingCopy,
				error: dojo.hitch(this, function(error, ioArgs) {
					this.displayDetailedErrorMessage(this.messages.failedSavingLicenses, error);
				})
			}));
		}
		
		var dl = new dojo.DeferredList(deferreds);
		dl.then(dojo.hitch(this, function(results) {
			var success = true;
			for (var i in results) {
				if (!results[i][0]) {
					success = false;
					break;
				}
			}
			if (success) {
				this.onLoadingComplete();
				this.refresh();
			}
		}));
		
	},
	
	displayDetailedErrorMessage: function (summary, error) {
	    if ( error.status == 412 ) {
	    	alert(this.messages.runningAlert);
	    } else {
	    	this.inherited(arguments);
	    }				
	},
	
	_updateJobs: function() {
		DataCollectionClient.getJobs({
			showAll: false,
			load: dojo.hitch(this, function(data, ioArgs) {
				var available = {};
				for (var jobId in data) {
					available[jobId] = true;
					if (this.items[jobId]) {
						this.items[jobId].jobStatus = data[jobId].status;
						this.items[jobId].displayName = data[jobId].title;
					}
				}
				this.availableItems = available;
				for (var i = 0; i < this.odsTable.tbody.rows.length; i++) {
					this.odsTable.tbody.rows[i].updateJob();
				}
				for (var i = 0; i < this.datamartTable.tbody.rows.length; i++) {
					this.datamartTable.tbody.rows[i].updateJob();
				}
				for (var i = 0; i < this.licensesTable.tbody.rows.length; i++) {
					this.licensesTable.tbody.rows[i].updateJob();
				}	
				if (this._runOdsJobsLink) {
					dojo.toggleClass(this._runOdsJobsLink, "hidden", false); //$NON-NLS-1$
					if (this._removeOdsScheduleLink) {
						if (this._odsSchedule) {
							dojo.toggleClass(this._removeOdsScheduleLink, "hidden", false); //$NON-NLS-1$
							dojo.toggleClass(this._removeOdsScheduleLink_bar, "hidden", false); //$NON-NLS-1$
						} 
					}
					if (this._editOdsScheduleLink) {
						if (this.odsCollection) {
							dojo.toggleClass(this._editOdsScheduleLink, "hidden", false); //$NON-NLS-1$
							dojo.toggleClass(this._editOdsScheduleLink_bar, "hidden", false); //$NON-NLS-1$
						} 
					}
					if (this._isDccEnabled) {
						for (var id in ODS_JOBS) {
							var item = this.items[id];
							if (item && this.availableItems[id]) {
								if (item.enabled === DataCollectionConstants.TRUE && item.jobStatus === DataCollectionConstants.RUNNING) {
									dojo.toggleClass(this._runOdsJobsLink, "hidden", true); //$NON-NLS-1$
									if (this._removeOdsScheduleLink) {
										dojo.toggleClass(this._removeOdsScheduleLink, "hidden", true); //$NON-NLS-1$
										dojo.toggleClass(this._removeOdsScheduleLink_bar, "hidden", true); //$NON-NLS-1$
									}
									if (this._editOdsScheduleLink) {
										dojo.toggleClass(this._editOdsScheduleLink, "hidden", true); //$NON-NLS-1$
										dojo.toggleClass(this._editOdsScheduleLink_bar, "hidden", true); //$NON-NLS-1$
									}
									break;
								}
							}
						}				
					}
				}
				if (this._runDatamartJobsLink) {
					dojo.toggleClass(this._runDatamartJobsLink, "hidden", false); //$NON-NLS-1$
					if (this._removeDatamartScheduleLink) {
						if (this._datamartSchedule) {
							dojo.toggleClass(this._removeDatamartScheduleLink, "hidden", false); //$NON-NLS-1$
							dojo.toggleClass(this._removeDatamartScheduleLink_bar, "hidden", false); //$NON-NLS-1$
						} 
					}
					if (this._editDatamartScheduleLink) {
						if (this.datamartCollection) {
							dojo.toggleClass(this._editDatamartScheduleLink, "hidden", false); //$NON-NLS-1$
							dojo.toggleClass(this._editDatamartScheduleLink_bar, "hidden", false); //$NON-NLS-1$
						} 
					}
					if (this._isDccEnabled) {
						for (var id in DATAMART_JOBS) {
							var item = this.items[id];
							if (item && this.availableItems[id]) {
								if (item.enabled === DataCollectionConstants.TRUE && item.jobStatus === DataCollectionConstants.RUNNING) {
									dojo.toggleClass(this._runDatamartJobsLink, "hidden", true); //$NON-NLS-1$
									if (this._removeDatamartScheduleLink) {
										dojo.toggleClass(this._removeDatamartScheduleLink, "hidden", true); //$NON-NLS-1$
										dojo.toggleClass(this._removeDatamartScheduleLink_bar, "hidden", true); //$NON-NLS-1$
									}
									if (this._editDatamartScheduleLink) {
										dojo.toggleClass(this._editDatamartScheduleLink, "hidden", true); //$NON-NLS-1$
										dojo.toggleClass(this._editDatamartScheduleLink_bar, "hidden", true); //$NON-NLS-1$
									}
									break;
								}
							}
						}	
					}
				}
				if (this._runLicensesJobsLink) {
					dojo.toggleClass(this._runLicensesJobsLink, "hidden", false); //$NON-NLS-1$
					if (this._removeLicensesScheduleLink) {
						if (this._licensesSchedule) {
							dojo.toggleClass(this._removeLicensesScheduleLink, "hidden", false); //$NON-NLS-1$
							dojo.toggleClass(this._removeLicensesScheduleLink_bar, "hidden", false); //$NON-NLS-1$
						} 
					}
					if (this._editLicensesScheduleLink) {
						if (this.licensesCollection) {
							dojo.toggleClass(this._editLicensesScheduleLink, "hidden", false); //$NON-NLS-1$
							dojo.toggleClass(this._editLicensesScheduleLink_bar, "hidden", false); //$NON-NLS-1$
						} 
					}
					if (this._isDccEnabled) {
						for (var id in LICENSES_JOBS) {
							var item = this.items[id];
							if (item && this.availableItems[id]) {
								if (item.enabled === DataCollectionConstants.TRUE && item.jobStatus === DataCollectionConstants.RUNNING) {
									dojo.toggleClass(this._runLicensesJobsLink, "hidden", true); //$NON-NLS-1$
									if (this._removeLicensesScheduleLink) {
										dojo.toggleClass(this._removeLicensesScheduleLink, "hidden", true); //$NON-NLS-1$
										dojo.toggleClass(this._removeLicensesScheduleLink_bar, "hidden", true); //$NON-NLS-1$
									}
									if (this._editLicensesScheduleLink) {
										dojo.toggleClass(this._editLicensesScheduleLink, "hidden", true); //$NON-NLS-1$
										dojo.toggleClass(this._editLicensesScheduleLink_bar, "hidden", true); //$NON-NLS-1$
									}
									break;
								}
							}
						}	
					}
				}							
			}),
			error: dojo.hitch(this, function(error, ioArgs) {
				this.displayDetailedErrorMessage(this.messages.loadJobsFailed, error);
			})
		});
	},
	
	_initializeContent: function () {
		var deferreds = [];
		
		// Load mapgroups
		deferreds.push(DataCollectionClient.getJobs({
			showAll: true,
			load: dojo.hitch(this, function(data, ioArgs) {
				for (var jobId in data) {
					var status = data[jobId].status;
					var item = {
						jobStatus: status,
						enabled:  data[jobId].enabled,
						displayName: data[jobId].title,
						name: jobId
					};
					this.items[jobId] = item;
				}
			}),
			error: dojo.hitch(this, function(error, ioArgs) {
				this.displayDetailedErrorMessage(this.messages.loadJobsFailed, error);
			})
		}));
		
		deferreds.push(DataCollectionClient.getJobs({
			showAll: false,
			load: dojo.hitch(this, function(data, ioArgs) {
				for (var jobId in data) {
					this.availableItems[jobId] = true;
				}
			}),
			error: dojo.hitch(this, function(error, ioArgs) {
				this.displayDetailedErrorMessage(this.messages.loadJobsFailed, error);
			})
		}));
		
		DataCollectionClient.getScheduledTask({
			id: ODS,
			load: dojo.hitch(this, function(data, ioArgs) {
				this.odsCollection = data;
				this._odsSchedule = this.odsCollection.schedule;
				this._updateOdsScheduleUi();
			}),
			error: dojo.hitch(this, function(error, ioArgs) {
				this.displayDetailedErrorMessage(this.messages.loadOdsCollectionFailed, error);
			})
		});
		
		DataCollectionClient.getScheduledTask({
			id: DATA_MART,
			load: dojo.hitch(this, function(data, ioArgs) {
				this.datamartCollection = data;
				this._datamartSchedule = this.datamartCollection.schedule;
				this._updateDatamartScheduleUi();
			}),
			error: dojo.hitch(this, function(error, ioArgs) {
				this.displayDetailedErrorMessage(this.messages.loadDataMartCollectionFailed, error);
			})
		});
		
		DataCollectionClient.getScheduledTask({
			id: LICENSES,
			load: dojo.hitch(this, function(data, ioArgs) {
				this.licensesCollection = data;
				this._licensesSchedule = this.licensesCollection.schedule;
				this._updateLicensesScheduleUi();
			}),
			error: dojo.hitch(this, function(error, ioArgs) {
				this.displayDetailedErrorMessage(this.messages.loadLicensesCollectionFailed, error);
			})
		});
		
		var dl = new dojo.DeferredList(deferreds);
		dl.then(dojo.hitch(this, function(results) {
			var success = true;
			for (var i in results) {
				if (!results[i][0]) {
					success = false;
					break;
				}
			}
			if (success) {
				this.onLoadingComplete();
				this._updateWarningMessage();
				dojo.empty(this.odsTable.tbody);
				dojo.empty(this.datamartTable.tbody);
				dojo.empty(this.licensesTable.tbody);
				for (var id in this.items) {
					if (ODS_JOBS[this.items[id].name]) {
						this.addRow(this.items[id], this.odsTable);
					} else if (DATAMART_JOBS[this.items[id].name]) {
						this.addRow(this.items[id], this.datamartTable);
					} else if (LICENSES_JOBS[this.items[id].name]) {
						this.addRow(this.items[id], this.licensesTable);
					}
				}
				// Setup recurring jobs availability and status refreshes
				this._autoJobsUpdate();
			}
		}));

	},
	
	_autoJobsUpdate: function() {
		this._updateJobs();
		this._timer = setTimeout(dojo.hitch(this, function() {
			this._autoJobsUpdate();
		}), REFRESH_RATE);
	},
	
	addRow: function(item, table) {
		var row, enabled, name, userId, password, actions, state, runButton, stopButton;
		row = document.createElement("tr"); //$NON-NLS-1$

		enabled = document.createElement("td"); //$NON-NLS-1$
		name = document.createElement("td"); //$NON-NLS-1$
		actions = document.createElement("td"); //$NON-NLS-1$
		state = document.createElement("td"); //$NON-NLS-1$

		dojo.addClass(enabled, "center-column"); //$NON-NLS-1$
		var enabledInput = document.createElement("input"); //$NON-NLS-1$
		enabledInput.type = "checkbox"; //$NON-NLS-1$
		enabled.appendChild(enabledInput);
		this.enableBoxes[item.name] = enabledInput;
		dojo.connect(enabledInput, "onclick", this, function(e) { //$NON-NLS-1$
			item.enabled = enabledInput.checked ? DataCollectionConstants.TRUE : DataCollectionConstants.FALSE;
			item.status = DataCollectionConstants.STATUS_UPDATE;
			this.setChange();
		});
		
		var toolbar = new Toolbar();

		// Run job button - index 0
		runButton = toolbar.addButton(this,
			function() {
				DataCollectionClient.executeTask({
					mapgroupId: item.name,
					load: dojo.hitch(this, function(data, ioArgs) {
						this._updateJobs();
					}),
					error: dojo.hitch(this, function(error, ioArgs) {
						this.displayDetailedErrorMessage(this.messages.executeTaskFailed, error);
					})
				});
			},
			{
				label: this.messages.runETLJob,
				imgSrc: dojo.moduleUrl("com.ibm.rational.datacollection.web","graphics/icons/run-etl-job_co.gif"), //$NON-NLS-1$
			}
		);
		
		// Stop job button
		stopButton = toolbar.addButton(this,
			function() {
				DataCollectionClient.stopTask({
					mapgroupId: item.name,
					load: dojo.hitch(this, function(data, ioArgs) {
						this._updateJobs();
					}),
					error: dojo.hitch(this, function(error, ioArgs) {
						this.displayDetailedErrorMessage(this.messages.executeTaskFailed, error);
					})
				});
			},
			{
				label: this.messages.stopETLJob,
				imgSrc: dojo.moduleUrl("com.ibm.rational.datacollection.web","graphics/icons/stop-etl-job_co.gif"), //$NON-NLS-1$
			}
		);			
		
		dojo.addClass(toolbar.domNode, "table-actions"); //$NON-NLS-1$
		toolbar.domNode.style.visibility = "hidden"; //$NON-NLS-1$
		row.item = item;
		row.onmouseover = dojo.hitch(this, function(e) {
			if (this._isDccEnabled && this.availableItems[item.name] && item.jobStatus 
					&& item.jobStatus !== DataCollectionConstants.STOPPING) {
				toolbar.domNode.style.visibility = "visible"; //$NON-NLS-1$
			}
		});
		row.onmouseout = dojo.hitch(this, function(e) {
			toolbar.domNode.style.visibility = "hidden"; //$NON-NLS-1$
		});
		actions.appendChild(toolbar.domNode);
		
		row.updateJob = dojo.hitch(this, function() {
			if (this.availableItems[item.name]) {
				dojo.removeClass(name, "greyedout"); //$NON-NLS-1$
				dojo.removeClass(state, "greyedout"); //$NON-NLS-1$
			} else {
				dojo.addClass(name, "greyedout"); //$NON-NLS-1$
				dojo.addClass(state, "greyedout"); //$NON-NLS-1$
			}
			state.innerHTML = item.jobStatus == DataCollectionConstants.IDLE ? 
					dojox.html.entities.encode(this.messages.idle) : 
						item.jobStatus == DataCollectionConstants.RUNNING ?  
								dojox.html.entities.encode(this.messages.running) : dojox.html.entities.encode(this.messages.stopping);
			enabledInput.disabled = !this._isDccEnabled || !this.availableItems[item.name] || item.jobStatus !== DataCollectionConstants.IDLE;
			enabledInput.checked = this.availableItems[item.name] && item.enabled === DataCollectionConstants.TRUE;
			name.innerHTML = dojox.html.entities.encode(item.displayName);
			
			// toolbar update
			if (this.availableItems[item.name] && this._isDccEnabled) {
				if (item.jobStatus === DataCollectionConstants.RUNNING) {
					dojo.toggleClass(runButton.domNode, "hidden", true); //$NON-NLS-1$
					dojo.toggleClass(stopButton.domNode, "hidden", false); //$NON-NLS-1$
				} else if (item.jobStatus === DataCollectionConstants.IDLE) {
					dojo.toggleClass(runButton.domNode, "hidden", false); //$NON-NLS-1$
					dojo.toggleClass(stopButton.domNode, "hidden", true); //$NON-NLS-1$
				} else {
					toolbar.domNode.style.visibility = "hidden"; //$NON-NLS-1$
				}
			} else {
				toolbar.domNode.style.visibility = "hidden"; //$NON-NLS-1$
			}
		});
		
		row.updateJob();

		row.appendChild(enabled);
		row.appendChild(name);
		row.appendChild(state);
		row.appendChild(actions);

		table.tbody.appendChild(row);
	},
	
	onLoadingComplete: function () {
		this.hideMessage();
	},
	
	setChange: function() {
		this.isDirty = true;
		this._updateSaveButtonEnablement();
	},
	
	_updateSaveButtonEnablement: function() {
		this._saveButton.disabled = !this.isDirty
		&& (!this.odsCollection || this._odsSchedule === this.odsCollection.schedule)
		&& (!this.datamartCollection || this._datamartSchedule === this.datamartCollection.schedule)
		&& (!this.licensesCollection || this._licensesSchedule === this.licensesCollection.schedule);
	},
	
	_updateSelectButtonEnablement: function() {
		if (this._isDccEnabled) {
			this._selectButton.disabled = false;
		} else {
			this._selectButton.disabled = true;
		}
	},
	
	refresh: function() {
		if (this._timer) {
			clearTimeout(this._timer);
		}
		this.hideMessage();
		this.displayInfoMessage(this.messages.loading);
		this.items = {};
		this.availableItems = {};
		this.enableBoxes = {};
		
		this.isDirty = false;
		
		this.odsCollection = null;
		this.datamartCollection = null;
		this.licensesCollection = null;
		
		this._odsSchedule = undefined;
		this._datamartSchedule = undefined;
		this._licensesSchedule = undefined;
		
		dojo.empty(this.odsTable.tbody);
		dojo.empty(this.datamartTable.tbody);
		dojo.empty(this.licensesTable.tbody);
		
		this._updateOdsScheduleUi();
		this._updateDatamartScheduleUi();
		this._updateLicensesScheduleUi();
		
		this._updateSaveButtonEnablement();
		this._updateSelectButtonEnablement();

		this._initializeContent();
	},
	
	_handleRunAllJobs : function(e) {
		e.preventDefault();
		var mapgroups = [];
		for (var id in this.items) {
			var item = this.items[id];
			if (this.availableItems[id] && item.enabled === DataCollectionConstants.TRUE && item.jobStatus === DataCollectionConstants.IDLE) {
				mapgroups.push(item.name);
			}
		}
		if (mapgroups.length > 0) {
			DataCollectionClient.executeTask({
				mapgroups: mapgroups,
				load: dojo.hitch(this, function(data, ioArgs) {
					this._updateJobs();
				}),
				error: dojo.hitch(this, function(error, ioArgs) {
					this.displayDetailedErrorMessage(this.messages.executeTaskFailed, error);
				})
			});
		} else {
			alert(this.messages.runningAlert);
		}
	},
	
	getUpdateItems: function() {
		var updateItems = [];
		for (var id in this.items) {
			if (this.items[id].status === DataCollectionConstants.STATUS_UPDATE) {
				var item = {};
				item["uri"] = net.jazz.ajax.contextRoot() + "/datacollection/resource/mapGroup/"+ this.items[id].name; //$NON-NLS-1$ //$NON-NLS-2$
				item["dcs:enabled"] = this.items[id].enabled; //$NON-NLS-1$
				updateItems.push(item);
			}
		}		
		return updateItems;
	},
	
	_runOdsJobs: function(e) {
		e.preventDefault();
		var mapgroups = [];
		for (var id in ODS_JOBS) {
			var item = this.items[id];
			if (item && this.availableItems[id]) {
				if (item.enabled === DataCollectionConstants.TRUE && item.jobStatus === DataCollectionConstants.IDLE) {
					mapgroups.push(id);
				}
			}
		}
		if (mapgroups.length > 0) {
			DataCollectionClient.executeTask({
				mapgroups: mapgroups,
				load: dojo.hitch(this, function(data, ioArgs) {
					this._updateJobs();
				}),
				error: dojo.hitch(this, function(error, ioArgs) {
					this.displayDetailedErrorMessage(this.messages.executeTaskFailed, error);
				})
			});
		} else {
			alert(this.messages.runningAlert);
		}
	},
	
	_editOdsSchedule: function(e) {
		e.preventDefault();
		var self= this;
		new ScheduleDialog({
			schedule: this._odsSchedule,
			onOk: function() {
				self._odsSchedule = this.getSchedule(self.odsCollection.schedule);
				self._updateSaveButtonEnablement();
				self._updateOdsScheduleUi();
			}
		});
	},
	
	_runDatamartJobs: function(e) {
		e.preventDefault();
		var mapgroups = [];
		for (var id in DATAMART_JOBS) {
			var item = this.items[id];
			if (item && this.availableItems[id]) {
				if (item.enabled === DataCollectionConstants.TRUE && item.jobStatus === DataCollectionConstants.IDLE) {
					mapgroups.push(id);
				}
			}
		}
		if (mapgroups.length > 0) {
			DataCollectionClient.executeTask({
				mapgroups: mapgroups,
				load: dojo.hitch(this, function(data, ioArgs) {
					this._updateJobs();
				}),
				error: dojo.hitch(this, function(error, ioArgs) {
					this.displayDetailedErrorMessage(this.messages.executeTaskFailed, error);
				})
			});
		} else {
			alert(this.messages.runningAlert);
		}
	},
	
	_editDatamartSchedule: function(e) {
		e.preventDefault();
		var self= this;
		new ScheduleDialog({
			schedule: this._datamartSchedule,
			onOk: function() {
				self._datamartSchedule = this.getSchedule(self.datamartCollection.schedule);
				self._updateSaveButtonEnablement();
				self._updateDatamartScheduleUi();
			}
		});
	},
	
	_runLicensesJobs: function(e) {
		e.preventDefault();
		var mapgroups = [];
		for (var id in LICENSES_JOBS) {
			var item = this.items[id];
			if (item && this.availableItems[id]) {
				if (item.enabled === DataCollectionConstants.TRUE && item.jobStatus === DataCollectionConstants.IDLE) {
					mapgroups.push(id);
				}
			}
		}
		if (mapgroups.length > 0) {
			DataCollectionClient.executeTask({
				mapgroups: mapgroups,
				load: dojo.hitch(this, function(data, ioArgs) {
					this._updateJobs();
				}),
				error: dojo.hitch(this, function(error, ioArgs) {
					this.displayDetailedErrorMessage(this.messages.executeTaskFailed, error);
				})
			});
		} else {
			alert(this.messages.runningAlert);
		}
	},
	
	_editLicensesSchedule: function(e) {
		e.preventDefault();
		var self= this;
		new ScheduleDialog({
			schedule: this._licensesSchedule,
			onOk: function() {
				self._licensesSchedule = this.getSchedule(self.licensesCollection.schedule);
				self._updateSaveButtonEnablement();
				self._updateLicensesScheduleUi();
			}
		});
	},
	
	_updateOdsScheduleUi: function() {
		if (!this._isDccEnabled) {
			if (this._removeOdsScheduleLink) {
				dojo.toggleClass(this._removeOdsScheduleLink, "hidden", true); //$NON-NLS-1$
				dojo.toggleClass(this._removeOdsScheduleLink_bar, "hidden", true); //$NON-NLS-1$
			}
			if (this._editOdsScheduleLink) {
				dojo.toggleClass(this._editOdsScheduleLink, "hidden", true); //$NON-NLS-1$
				dojo.toggleClass(this._editOdsScheduleLink_bar, "hidden", true); //$NON-NLS-1$
			}
		} else {
			if (this.odsCollection && this.odsCollection.schedule === this._odsSchedule) {
				if (this.odsCollection.nextTime) {
					var date = new Date(this.odsCollection.nextTime);
					this.odsNextTime.innerHTML = this.messages.scheduledOn + dojox.html.entities.encode(date.toLocaleString());
				} else if (this.odsCollection.schedule) {
					this.odsNextTime.innerHTML = dojox.html.entities.encode(this.messages.scheduled);
				} else {
					this.odsNextTime.innerHTML = ""; //$NON-NLS-1$
				}
			} else {
				if (this._odsSchedule) {
					this.odsNextTime.innerHTML = dojox.html.entities.encode(this.messages.scheduled);				
				} else {
					this.odsNextTime.innerHTML = ""; //$NON-NLS-1$
				}
			}
			if (this._removeOdsScheduleLink) {
				if (this._odsSchedule) {
					dojo.toggleClass(this._removeOdsScheduleLink, "hidden", false); //$NON-NLS-1$
					dojo.toggleClass(this._removeOdsScheduleLink_bar, "hidden", false); //$NON-NLS-1$
				} else {
					dojo.toggleClass(this._removeOdsScheduleLink, "hidden", true); //$NON-NLS-1$
					dojo.toggleClass(this._removeOdsScheduleLink_bar, "hidden", true); //$NON-NLS-1$
				}
			}
			if (this._editOdsScheduleLink) {
				if (this.odsCollection) {
					dojo.toggleClass(this._editOdsScheduleLink, "hidden", false); //$NON-NLS-1$
					dojo.toggleClass(this._editOdsScheduleLink_bar, "hidden", false); //$NON-NLS-1$
				} else {
					dojo.toggleClass(this._editOdsScheduleLink, "hidden", true); //$NON-NLS-1$
					dojo.toggleClass(this._editOdsScheduleLink_bar, "hidden", true); //$NON-NLS-1$
				}
			}
		}
				
	},
	
	_updateDatamartScheduleUi: function() {
		if (!this._isDccEnabled) {
			if (this._removeDatamartScheduleLink) {
				dojo.toggleClass(this._removeDatamartScheduleLink, "hidden", true); //$NON-NLS-1$
				dojo.toggleClass(this._removeDatamartScheduleLink_bar, "hidden", true); //$NON-NLS-1$
			}
			if (this._editDatamartScheduleLink) {
				dojo.toggleClass(this._editDatamartScheduleLink, "hidden", true); //$NON-NLS-1$
				dojo.toggleClass(this._editDatamartScheduleLink_bar, "hidden", true); //$NON-NLS-1$
			}
		} else {
			if (this.datamartCollection && this.datamartCollection.schedule === this._datamartSchedule) {
				if (this.datamartCollection.nextTime) {
					var date = new Date(this.datamartCollection.nextTime);
					this.datamartNextTime.innerHTML = this.messages.scheduledOn + dojox.html.entities.encode(date.toLocaleString());
				} else if (this.datamartCollection.schedule) {
					this.datamartNextTime.innerHTML = dojox.html.entities.encode(this.messages.scheduled);
				} else {
					this.datamartNextTime.innerHTML = ""; //$NON-NLS-1$
				}
			} else {
				if (this._datamartSchedule) {
					this.datamartNextTime.innerHTML = dojox.html.entities.encode(this.messages.scheduled);				
				} else {
					this.datamartNextTime.innerHTML = ""; //$NON-NLS-1$
				}
			}		
			if (this._removeDatamartScheduleLink) {
				if (this._datamartSchedule) {
					dojo.toggleClass(this._removeDatamartScheduleLink, "hidden", false); //$NON-NLS-1$
					dojo.toggleClass(this._removeDatamartScheduleLink_bar, "hidden", false); //$NON-NLS-1$
				} else {
					dojo.toggleClass(this._removeDatamartScheduleLink, "hidden", true); //$NON-NLS-1$
					dojo.toggleClass(this._removeDatamartScheduleLink_bar, "hidden", true); //$NON-NLS-1$
				}
			}
			if (this._editDatamartScheduleLink) {
				if (this.datamartCollection) {
					dojo.toggleClass(this._editDatamartScheduleLink, "hidden", false); //$NON-NLS-1$
					dojo.toggleClass(this._editDatamartScheduleLink_bar, "hidden", false); //$NON-NLS-1$
				} else {
					dojo.toggleClass(this._editDatamartScheduleLink, "hidden", true); //$NON-NLS-1$
					dojo.toggleClass(this._editDatamartScheduleLink_bar, "hidden", true); //$NON-NLS-1$
				}
			}
		}
		
	},
	
	_updateLicensesScheduleUi: function() {
		if (!this._isDccEnabled) {
			if (this._removeLicensesScheduleLink) {
				dojo.toggleClass(this._removeLicensesScheduleLink, "hidden", true); //$NON-NLS-1$
				dojo.toggleClass(this._removeLicensesScheduleLink_bar, "hidden", true); //$NON-NLS-1$
			}
			if (this._editLicensesScheduleLink) {
				dojo.toggleClass(this._editLicensesScheduleLink, "hidden", true); //$NON-NLS-1$
				dojo.toggleClass(this._editLicensesScheduleLink_bar, "hidden", true); //$NON-NLS-1$
			}
		} else {
			if (this.licensesCollection && this.licensesCollection.schedule === this._licensesSchedule) {
				if (this.licensesCollection.nextTime) {
					var date = new Date(this.licensesCollection.nextTime);
					this.licensesNextTime.innerHTML = this.messages.scheduledOn + dojox.html.entities.encode(date.toLocaleString());
				} else if (this.licensesCollection.schedule) {
					this.licensesNextTime.innerHTML = dojox.html.entities.encode(this.messages.scheduled);
				} else {
					this.licensesNextTime.innerHTML = ""; //$NON-NLS-1$
				}
			} else {
				if (this._licensesSchedule) {
					this.licensesNextTime.innerHTML = dojox.html.entities.encode(this.messages.scheduled);				
				} else {
					this.licensesNextTime.innerHTML = ""; //$NON-NLS-1$
				}
			}
			if (this._removeLicensesScheduleLink) {
				if (this._licensesSchedule) {
					dojo.toggleClass(this._removeLicensesScheduleLink, "hidden", false); //$NON-NLS-1$
					dojo.toggleClass(this._removeLicensesScheduleLink_bar, "hidden", false); //$NON-NLS-1$
				} else {
					dojo.toggleClass(this._removeLicensesScheduleLink, "hidden", true); //$NON-NLS-1$
					dojo.toggleClass(this._removeLicensesScheduleLink_bar, "hidden", true); //$NON-NLS-1$
				}
			}
			if (this._editLicensesScheduleLink) {
				if (this.licensesCollection) {
					dojo.toggleClass(this._editLicensesScheduleLink, "hidden", false); //$NON-NLS-1$
					dojo.toggleClass(this._editLicensesScheduleLink_bar, "hidden", false); //$NON-NLS-1$
				} else {
					dojo.toggleClass(this._editLicensesScheduleLink, "hidden", true); //$NON-NLS-1$
					dojo.toggleClass(this._editLicensesScheduleLink_bar, "hidden", true); //$NON-NLS-1$
				}
			}
		}
	
	},
	
	_removeLicensesSchedule: function() {
		this._licensesSchedule = undefined;
		this._updateSaveButtonEnablement();
		this._updateLicensesScheduleUi();
	},
	
	_removeOdsSchedule: function() {
		this._odsSchedule = undefined;
		this._updateSaveButtonEnablement();
		this._updateOdsScheduleUi();
	},

	_removeDatamartSchedule: function() {
		this._datamartSchedule = undefined;
		this._updateSaveButtonEnablement();
		this._updateDatamartScheduleUi();
	},
	
	uninitialize: function(){
		if (this._timer) {
			clearTimeout(this._timer);
		}
		this.inherited(arguments);
	},
	
});

})();