/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.rational.datacollection.web.ui.internal.editors.ResourceGroupSection"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.StringParameter"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.StringSelectProperty"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.StringProperty"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.Section"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.ResourceHelper");//$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionClient"); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$
dojo.require("jazz.app.ua.PageHoverHelp"); //$NON-NLS-1$
dojo.require("jazz.app.ua.TextHoverHelp"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojox.html.entities"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "ResourceGroupSectionMessages"); //$NON-NLS-1$ //$NON-NLS-2$


(function() {
var StringParameter = com.ibm.rational.datacollection.web.ui.internal.editors.StringParameter;
var StringSelectProperty = com.ibm.rational.datacollection.web.ui.internal.editors.StringSelectProperty;
var StringProperty = com.ibm.rational.datacollection.web.ui.internal.editors.StringProperty;
var Section = com.ibm.rational.datacollection.web.ui.internal.editors.Section;
var ResourceHelper = com.ibm.rational.datacollection.web.ui.internal.common.ResourceHelper;
var DataCollectionConstants = com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants;
var DataCollectionClient = com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionClient;
var PageHoverHelp = jazz.app.ua.PageHoverHelp;
var TextHoverHelp = jazz.app.ua.TextHoverHelp;

var dbUrlHints = {};
dbUrlHints[DataCollectionConstants.DB_TYPE_DB2_VALUE] = "//<server>:<port>/<DB Alias>"; //$NON-NLS-1$
dbUrlHints[DataCollectionConstants.DB_TYPE_ORACLE_VALUE] = "thin:@//<server>:<port>/databaseName"; //$NON-NLS-1$
dbUrlHints[DataCollectionConstants.DB_TYPE_SQLSERVER_VALUE] = "//<server>:<port>;databaseName=<DB Alias>;integratedSecurity=<true or false>"; //$NON-NLS-1$
dbUrlHints[DataCollectionConstants.DB_TYPE_DERBY_CLIENT_VALUE] = "//<server>:<port>/<DB Alias>"; //$NON-NLS-1$

var dbTypeOptions = [
    {name : DataCollectionConstants.DB_TYPE_DB2_NAME, value : DataCollectionConstants.DB_TYPE_DB2_VALUE},
    {name : DataCollectionConstants.DB_TYPE_ORACLE_NAME, value : DataCollectionConstants.DB_TYPE_ORACLE_VALUE},
    {name : DataCollectionConstants.DB_TYPE_SQLSERVER_NAME, value : DataCollectionConstants.DB_TYPE_SQLSERVER_VALUE},
    {name : DataCollectionConstants.DB_TYPE_DERBY_CLIENT_NAME, value : DataCollectionConstants.DB_TYPE_DERBY_CLIENT_VALUE}
];



dojo.declare("com.ibm.rational.datacollection.web.ui.internal.editors.ResourceGroupSection", Section, { //$NON-NLS-1$
	templatePath: dojo.moduleUrl("com.ibm.rational.datacollection.web", "ui/internal/editors/templates/ResourceGroupSection.html"), //$NON-NLS-1$ //$NON-NLS-2$
	parameters: null,
	properties: null,
	data: null,
	controller: null,
	lockId: false,
	displayParameterTable: false,
	identifier: null,
	widgets: {},
		
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "ResourceGroupSectionMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.data = {};
		this.parameters = [];
		this.properties = [			
			{  
		    	name : this.messages.propertyTitleName,
		    	url : DataCollectionConstants.NS_TITLE,
		    	description : this.messages.propertyTitleDescpt,
				defaultValue : this.messages.propertyTitleName
			},
			{  
		    	name : this.messages.propertyBaseURLName,
		    	url : DataCollectionConstants.NS_BASE_URL,
		    	description : this.messages.propertyBaseURLDescpt,
				defaultValue : this.messages.propertyBaseURLDefaultValue
			},
			{  
		    	name : this.messages.propertyAuthName,
		    	url : DataCollectionConstants.NS_AUTH_TYPE,
		    	description : this.messages.propertyAuthDescpt,
				defaultValue : this.messages.propertyAuthDefaultValue
		 	},
			{  
		    	name : this.messages.propertyUserName,
		    	url : DataCollectionConstants.NS_USERNAME,
		    	description : this.messages.propertyUserDescpt,
				defaultValue : this.messages.propertyUserDefaultValue
		 	},
			{  
		    	name : this.messages.propertyPasswordName,
		    	url : DataCollectionConstants.NS_PASSWORD,
		    	description : this.messages.propertyPasswordDescpt,
				defaultValue : this.messages.propertyPasswordDefaultValue
			},
			{  
		    	name : this.messages.propertyVersionName,
		    	url : DataCollectionConstants.NS_VERSION,
		    	description : this.messages.propertyVersionDescpt,
				defaultValue : this.messages.propertyVersionDefaultValue
			}
//			{  
//		    	name : this.messages.propertyEnabledName,
//		    	url : DataCollectionConstants.NS_ENABLED,
//		    	description : this.messages.propertyEnabledDescpt,
//				defaultValue : this.messages.propertyEnabledDefaultValue
//		 	},
//			{  
//		    	name : this.messages.propertySupportQueryName,
//		    	url : DataCollectionConstants.NS_SUPPORT_QUERY,
//		    	description : this.messages.propertySupportQueryDescpt,
//				defaultValue : this.messages.propertySupportQueryDefaultValue
//		 	}

		];
	},
	
	postCreate: function () {
		this._customizeProperties();
		this._initializeContent();
	},
	
	_customizeProperties: function() {
		if (this.identifier === DataCollectionConstants.APPID_RDB) {
			this.displayParameterTable = true;
			this.properties = [
			       			{  
			       		    	name : this.messages.propertyTitleName,
			       		    	url : DataCollectionConstants.NS_TITLE,
			       		    	description : this.messages.propertyTitleDescpt,
			       				defaultValue : this.messages.propertyTitleName
			       			},
			       			{  
			       				name : this.messages.dbTypeTitle,
			       				url : DataCollectionConstants.NS_DB_TYPE,
			       				description : this.messages.dbTypeDescription,
			       				defaultValue : "", //$NON-NLS-1$
			       			},
			       			{  
			       		    	name : this.messages.propertyBaseURLName,
			       		    	url : DataCollectionConstants.NS_BASE_URL,
			       		    	description : this.messages.propertyBaseURLDescpt,
			       				defaultValue : this.messages.propertyBaseURLDefaultValue
			       			},
			    			{  
			    		    	name : this.messages.propertyAuthName,
			    		    	url : DataCollectionConstants.NS_AUTH_TYPE,
			    		    	description : this.messages.propertyAuthDescpt,
			    				defaultValue : DataCollectionConstants.AUTH_TYPE_JDBC_NAME
			    		 	},
			       			{  
			       		    	name : this.messages.propertyUserName,
			       		    	url : DataCollectionConstants.NS_USERNAME,
			       		    	description : this.messages.propertyUserDescpt,
			       				defaultValue : this.messages.propertyUserDefaultValue
			       		 	},
			       			{  
			       		    	name : this.messages.propertyPasswordName,
			       		    	url : DataCollectionConstants.NS_PASSWORD,
			       		    	description : this.messages.propertyPasswordDescpt,
			       				defaultValue : this.messages.propertyPasswordDefaultValue
			       			},
			    			{  
			    		    	name : this.messages.propertyVersionName,
			    		    	url : DataCollectionConstants.NS_VERSION,
			    		    	description : this.messages.propertyVersionDescpt,
			    				defaultValue : this.messages.propertyVersionDefaultValue
			    			}
			       		];
		}
	},

	_initializeContent: function () {
		var _self = this;
		this.widgets = {};
		
		//relational database group cannot be deleted
		if (this.identifier === DataCollectionConstants.APPID_RDB) {
			dojo.toggleClass(this._deleteLink, "hide", true);
			dojo.toggleClass(this._actionBarSeparator, "hide", true);
		}
		
		for (var i =0; i < this.properties.length; i++) {
			var property = this.properties[i];
			var value;
			var resourceId = this.data.resourceId;
			var resourceGroup = ResourceHelper.getResourceGroup(this.data.data);
			var authConfig = ResourceHelper.getAuthenticationConfiguration(this.data.data);
			var readonly = false;
			var defaultValue = null;
			if (property.url === DataCollectionConstants.NS_AUTH_TYPE || property.url === DataCollectionConstants.NS_USERNAME || property.url === DataCollectionConstants.NS_PASSWORD) {
				value = authConfig[property.url][0].value;
			} else if (property.url === DataCollectionConstants.RESOURCE_GROUP_NAME) {
				value = resourceId;
				readonly = this.lockId;
				defaultValue = value;
			} else if (property.url === DataCollectionConstants.NS_SUPPORT_QUERY) {
				if(undefined === resourceGroup[property.url]){
					value = "TRUE";  //$NON-NLS-1$
				}else{
					value = resourceGroup[property.url][0].value;
				}
			} else {
				if(undefined === resourceGroup[property.url]){
					resourceGroup[property.url] = [{}];
				}
				value = resourceGroup[property.url][0].value;
				if (property.url === DataCollectionConstants.NS_TITLE) {
				    this.setTitle(value);
					defaultValue = value;
				} else if (property.url === DataCollectionConstants.NS_BASE_URL && this.controller.isRM()) {
					defaultValue = property.defaultValue;
				} else if (property.url === DataCollectionConstants.NS_BASE_URL) {
					if (this.widgets[DataCollectionConstants.NS_DB_TYPE]) {
						var hintKey = resourceGroup[DataCollectionConstants.NS_DB_TYPE][0].value;
						defaultValue = dojox.html.entities.encode(dbUrlHints[hintKey]);
					}
				}
			}
			var propertyWidget = null;
			var name = property.name;
			var hoverHelp = property.description;
			var authType = authConfig[DataCollectionConstants.NS_AUTH_TYPE ][0].value;
			if(authType === DataCollectionConstants.AUTH_TYPE_JFS_VALUE){
				if(property.url === DataCollectionConstants.NS_USERNAME ){
					name = this.messages.propertyJFSConsumer;
					hoverHelp = this.messages.propertyJFSConsumerDescpt;
				}else if(property.url === DataCollectionConstants.NS_PASSWORD){
					name = this.messages.propertyJFSSecret;
					hoverHelp = this.messages.propertyJFSSecretDescpt;					
				}
			}
			
			if(property.url !== DataCollectionConstants.NS_SUPPORT_QUERY 
					&& property.url !== DataCollectionConstants.NS_AUTH_TYPE 
					&& property.url !== DataCollectionConstants.NS_RESOURCE_GROUP_TYPE 
					&& property.url !== DataCollectionConstants.NS_VERSION
					&& property.url !== DataCollectionConstants.NS_DB_TYPE){ //
				propertyWidget = new StringProperty({
					"name": name,  //$NON-NLS-1$
					"key": property.url,  //$NON-NLS-1$
					"textHoverHelp": hoverHelp,  //$NON-NLS-1$
					"defaultValue": defaultValue ? defaultValue : property.defaultValue,  //$NON-NLS-1$
					"value": value ? value : "",  //$NON-NLS-1$ //$NON-NLS-2$
					"readonly": readonly,  //$NON-NLS-1$ //$NON-NLS-2$
					"isPassword": property.url === DataCollectionConstants.NS_PASSWORD? true:false, //$NON-NLS-1$
				    "onChange": function(value) { //$NON-NLS-1$
						var property = this.key;
						if (property === DataCollectionConstants.RESOURCE_GROUP_NAME) {
							_self.data.resourceId = value;
						} else if (property === DataCollectionConstants.NS_AUTH_TYPE || property === DataCollectionConstants.NS_USERNAME || property === DataCollectionConstants.NS_PASSWORD) {
							authConfig[property][0].value = value;
						} else {
							if(undefined === resourceGroup[property]){
								resourceGroup[property] = [{}];
								resourceGroup[property][0]["type"] = "literal"; //$NON-NLS-1$ //$NON-NLS-2$
								resourceGroup[property][0]["value"] = ""; //$NON-NLS-1$ //$NON-NLS-2$
							} 
							resourceGroup[property][0].value = value;
							if ( property === DataCollectionConstants.NS_TITLE) {
								_self.setTitle(value);
							}
						}
						
						var rscGroupName = resourceGroup[DataCollectionConstants.NS_TITLE][0].value;
						if("" !== rscGroupName){ //$NON-NLS-1$
							
							var reg = /^([a-zA-Z0-9\s()_-]+)*$/; //$NON-NLS-1$
							var result = reg.exec(rscGroupName);
							if(!result){
								_self.controller.controller.displayErrorMessage(_self.messages.errorIllegalRscGroupName);
								_self.controller.controller.resetSaveButton();
								return;
							}else{
								
								_self.controller.controller.hideMessage();
							}
						}
						
						_self.data.status = ResourceHelper.calculateStatus(_self.data.status, DataCollectionConstants.STATUS_UPDATE);
						_self.setChange();
					}
				});
			}else{
				
				var options = null;
				
				if( property.url === DataCollectionConstants.NS_SUPPORT_QUERY){
					options = [
					    {name:"true", value: "true"}, //$NON-NLS-1$ //$NON-NLS-2$
					    {name:"false", value: "false"} //$NON-NLS-1$ //$NON-NLS-2$
					];
				}else if( property.url === DataCollectionConstants.NS_AUTH_TYPE) {
					if (this.identifier === DataCollectionConstants.APPID_RDB) {
						options = [
							{name:DataCollectionConstants.AUTH_TYPE_JDBC_NAME, value: DataCollectionConstants.AUTH_TYPE_JDBC_VALUE} //$NON-NLS-1$ //$NON-NLS-2$
						];
					} else {
						options = [
							{name:this.messages.propertyAuthDefaultValue, value: DataCollectionConstants.AUTH_TYPE_BASIC_VALUE}, //$NON-NLS-1$ //$NON-NLS-2$
						    {name:DataCollectionConstants.AUTH_TYPE_JFS_NAME, value: DataCollectionConstants.AUTH_TYPE_JFS_VALUE} //$NON-NLS-1$ //$NON-NLS-2$
						];
					}
				} else if (property.url === DataCollectionConstants.NS_VERSION) {
					options = [
						{name:DataCollectionConstants.VERSION_50_NAME, value: DataCollectionConstants.VERSION_50_VALUE}   /*, //$NON-NLS-1$ //$NON-NLS-2$
						{name:DataCollectionConstants.VERSION_406_NAME, value: DataCollectionConstants.VERSION_406_VALUE}, //$NON-NLS-1$ //$NON-NLS-2$
						{name:DataCollectionConstants.VERSION_405_NAME, value: DataCollectionConstants.VERSION_405_VALUE}, //$NON-NLS-1$ //$NON-NLS-2$
						{name:DataCollectionConstants.VERSION_404_NAME, value: DataCollectionConstants.VERSION_404_VALUE}, //$NON-NLS-1$ //$NON-NLS-2$
						{name:DataCollectionConstants.VERSION_403_NAME, value: DataCollectionConstants.VERSION_403_VALUE} //$NON-NLS-1$ //$NON-NLS-2$
						*/
				    ];
				} else if (property.url === DataCollectionConstants.NS_DB_TYPE) {
					options = dbTypeOptions;
				} 
								
				var name = property.name;
				var hoverHelp = property.description;
				
				propertyWidget = new StringSelectProperty({
					"name": name,  //$NON-NLS-1$
					"key": property.url,  //$NON-NLS-1$
					"textHoverHelp": hoverHelp,  //$NON-NLS-1$
					"defaultValue": property.defaultValue,  //$NON-NLS-1$
					"value": value ? value : "",  //$NON-NLS-1$ //$NON-NLS-2$
					"readonly": readonly,  //$NON-NLS-1$ //$NON-NLS-2$
				    "onChange": function(value) { //$NON-NLS-1$
						var property = this.key;
						if (property === DataCollectionConstants.RESOURCE_GROUP_NAME) {
							_self.data.resourceId = value;
						} else if (property === DataCollectionConstants.NS_AUTH_TYPE || property === DataCollectionConstants.NS_USERNAME || property === DataCollectionConstants.NS_PASSWORD) {
							authConfig[property][0].value = value;
							if(value === DataCollectionConstants.AUTH_TYPE_JFS_VALUE){ 
								_self.widgets[DataCollectionConstants.NS_USERNAME]._propertyName.innerHTML = _self.messages.propertyJFSConsumer;
								_self.widgets[DataCollectionConstants.NS_USERNAME].textHoverHelp = _self.messages.propertyJFSConsumerDescpt;
								_self.widgets[DataCollectionConstants.NS_USERNAME].prepareTextHoverHelp();
								_self.widgets[DataCollectionConstants.NS_PASSWORD]._propertyName.innerHTML = _self.messages.propertyJFSSecret;
								_self.widgets[DataCollectionConstants.NS_PASSWORD].textHoverHelp = _self.messages.propertyJFSSecretDescpt;
								_self.widgets[DataCollectionConstants.NS_PASSWORD].prepareTextHoverHelp();
								
							}else{
								_self.widgets[DataCollectionConstants.NS_USERNAME]._propertyName.innerHTML = _self.messages.propertyUserName;
								_self.widgets[DataCollectionConstants.NS_USERNAME].textHoverHelp = _self.messages.propertyUserDescpt;
								_self.widgets[DataCollectionConstants.NS_USERNAME].prepareTextHoverHelp();
								_self.widgets[DataCollectionConstants.NS_PASSWORD]._propertyName.innerHTML = _self.messages.propertyPasswordName;
								_self.widgets[DataCollectionConstants.NS_PASSWORD].textHoverHelp = _self.messages.propertyPasswordDescpt;
								_self.widgets[DataCollectionConstants.NS_PASSWORD].prepareTextHoverHelp();
							}
							
							if(value == DataCollectionConstants.AUTH_TYPE_NONE_VALUE ){
								_self.widgets[DataCollectionConstants.NS_USERNAME].editValue.value = ""; //$NON-NLS-1$
								_self.widgets[DataCollectionConstants.NS_PASSWORD].passwordValue.value = ""; //$NON-NLS-1$
								_self._propertiesTable.removeChild(_self.widgets[DataCollectionConstants.NS_USERNAME].domNode);
								_self._propertiesTable.removeChild(_self.widgets[DataCollectionConstants.NS_PASSWORD].domNode);
							}else{
								_self._propertiesTable.appendChild(_self.widgets[DataCollectionConstants.NS_USERNAME].domNode);
								_self._propertiesTable.appendChild(_self.widgets[DataCollectionConstants.NS_PASSWORD].domNode);
							}

						} else {
							if(undefined === resourceGroup[property]){
								resourceGroup[property] = [{}];
								resourceGroup[property][0]["type"] = "literal"; //$NON-NLS-1$ //$NON-NLS-2$
								resourceGroup[property][0]["value"] = ""; //$NON-NLS-1$ //$NON-NLS-2$
							} 
							resourceGroup[property][0].value = value;
							if (property === DataCollectionConstants.NS_DB_TYPE) {
								if (_self.widgets[DataCollectionConstants.NS_BASE_URL]) {
									_self.widgets[DataCollectionConstants.NS_BASE_URL]._propertyDefault.innerHTML = dojox.html.entities.encode(dbUrlHints[value]);
								}
							}
							if (property === DataCollectionConstants.NS_TITLE) {
								_self.setTitle(value);
							}
						}
						_self.data.status = ResourceHelper.calculateStatus(_self.data.status, DataCollectionConstants.STATUS_UPDATE);
						_self.setChange();
					},
					"options": options //$NON-NLS-1$
				});
			}
			
			this.properties[i].widget = propertyWidget;
			this._propertiesTable.appendChild(propertyWidget.domNode);
			if (property.url) {
				this.widgets[property.url] = propertyWidget;
			}
			
			// Currently only JDBC auth for RDB ResourceGroup
			if (property.url == DataCollectionConstants.NS_AUTH_TYPE 
					&& this.identifier === DataCollectionConstants.APPID_RDB) {
				propertyWidget.editValue.disabled = true;
			}
			
			if(this.widgets[DataCollectionConstants.NS_AUTH_TYPE] != null
					&& this.widgets[DataCollectionConstants.NS_AUTH_TYPE].value == DataCollectionConstants.AUTH_TYPE_NONE_VALUE) {
				propertyWidget.editValue.value = ""; //$NON-NLS-1$
				propertyWidget.passwordValue.value = ""; //$NON-NLS-1$
				continue;
			}
			
		}
		
		if (this.displayParameterTable) {
			this._parametersArea.style.display = ""; //$NON-NLS-1$
			var parameterArray = ResourceHelper.getParameterArray(this.data.data);
			for (var i = 0; i < parameterArray.length; i++) {
				var name = parameterArray[i][DataCollectionConstants.NS_NAME][0]["value"]; //$NON-NLS-1$
				var type = parameterArray[i][DataCollectionConstants.NS_VALUE] ? type = DataCollectionConstants.NS_VALUE : DataCollectionConstants.NS_LOCAL_TRANSFORM;
				var value = parameterArray[i][type][0]["value"]; //$NON-NLS-1$
				var parameterWidget = new StringParameter({
					controller: this,
					data: parameterArray[i],
					name: name,
					value: value,
					type: type,
					types: [
					    {name:DataCollectionConstants.PARAMETER_TYPE_VALUE_NAME, value: DataCollectionConstants.NS_VALUE},
					    {name:DataCollectionConstants.PARAMETER_TYPE_LOCAL_TRANSFORM_NAME, value: DataCollectionConstants.NS_LOCAL_TRANSFORM},
					],
					onValueChange: function() {
						if (this.type === DataCollectionConstants.NS_LOCAL_TRANSFORM) {
							if (this.data[DataCollectionConstants.NS_VALUE]) {
								delete this.data[DataCollectionConstants.NS_VALUE];
							}
							
							if (!this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM]) {
								this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM] = [{}];
								this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM][0]["type"] = "literal"; //$NON-NLS-1$ //$NON-NLS-2$
							}
							this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM][0]["value"] = this.value; //$NON-NLS-1$ //$NON-NLS-2$
						} else {
							if (this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM]) {
								delete this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM];
							}
							
							if (!this.data[DataCollectionConstants.NS_VALUE]) {
								this.data[DataCollectionConstants.NS_VALUE] = [{}];
								this.data[DataCollectionConstants.NS_VALUE][0]["type"] = "literal"; //$NON-NLS-1$ //$NON-NLS-2$
							}
							this.data[DataCollectionConstants.NS_VALUE][0]["value"] = this.value; //$NON-NLS-1$
						}
						_self.data.status = ResourceHelper.calculateStatus(_self.data.status, DataCollectionConstants.STATUS_UPDATE);
					},
					onTypeChange: function() {
						if (this.type === DataCollectionConstants.NS_LOCAL_TRANSFORM) {
							if (this.data[DataCollectionConstants.NS_VALUE]) {
								delete this.data[DataCollectionConstants.NS_VALUE];
							}
							
							if (!this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM]) {
								this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM] = [{}];
								this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM][0]["type"] = "literal"; //$NON-NLS-1$ //$NON-NLS-2$
							}
							this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM][0]["value"] = this.value; //$NON-NLS-1$
						} else {
							if (this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM]) {
								delete this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM];
							}
							
							if (!this.data[DataCollectionConstants.NS_VALUE]) {
								this.data[DataCollectionConstants.NS_VALUE] = [{}];
								this.data[DataCollectionConstants.NS_VALUE][0]["type"] = "literal"; //$NON-NLS-1$ //$NON-NLS-2$
							}
							this.data[DataCollectionConstants.NS_VALUE][0]["value"] = this.value; //$NON-NLS-1$
						}
						_self.data.status = ResourceHelper.calculateStatus(_self.data.status, DataCollectionConstants.STATUS_UPDATE);
					},
					onNameChange: function() {
						this.data[DataCollectionConstants.NS_NAME][0]["value"] = this.name; //$NON-NLS-1$
						_self.data.status = ResourceHelper.calculateStatus(_self.data.status, DataCollectionConstants.STATUS_UPDATE);
					}
				});
				this.parameters.push(parameterWidget);
				this._parametersTable.appendChild(parameterWidget.domNode);
			}
		}
		
	},
	
	toggleEditMode: function (edit) {
		for (var property in this.properties) {
			this.properties[property].widget.toggleEditMode(edit);
		}
		for (var parameter in this.parameters) {
			this.parameters[parameter].toggleEditMode(edit);
		} 
	},
	
	_onTestClick: function(evt) {	
		dojo.stopEvent(evt);
		this.testConnection();	
	},
	
	testConnection: function(){
		var _self = this;
		jazz.ui.underlay.show();
		_self.controller.controller.displayInfoMessage(_self.messages.testRsrcGroup);
		DataCollectionClient.testResourceGroupConnection({
			data: this.data.data,
			resourceId: this.data.resourceId,
			load: dojo.hitch(this, function(response, ioArgs) {
				if (response !== null && response.code == "ERROR") { //$NON-NLS-1$
					_self.controller.controller.displayDetailedErrorMessage(_self.messages.testRsrcGroupFail, response);
				}else{
					_self.controller.controller.displaySuccessMessage(_self.messages.testRsrcGroupOk);
				}
				
				jazz.ui.underlay.hide();
			}),
			error: dojo.hitch(this, function(error, ioArgs) {
				_self.controller.controller.displayDetailedErrorMessage(_self.messages.testRsrcGroupFail, error);
				jazz.ui.underlay.hide();
			})
		});
	},
	
	_onDeleteClick: function(evt) {
		dojo.stopEvent(evt);
		this.data.status = ResourceHelper.calculateStatus(this.data.status, DataCollectionConstants.STATUS_DELETE);
		this.controller.removeItem(this);
	},
	
	_onAddParameterClick: function(evt) {
		dojo.stopEvent(evt);
		var _self = this; 
		this.data.status = ResourceHelper.calculateStatus(this.data.status, DataCollectionConstants.STATUS_UPDATE);
		var parameter = this.getWorkingCopy().createParameter(this.data);
		
		var parameterWidget = new StringParameter({
			controller: this,
			data: parameter,
			name: "", //$NON-NLS-1$
			value: "", //$NON-NLS-1$
			type: DataCollectionConstants.NS_LOCAL_TRANSFORM,
			types: [
			    {name:DataCollectionConstants.PARAMETER_TYPE_VALUE_NAME, value: DataCollectionConstants.NS_VALUE},
			    {name:DataCollectionConstants.PARAMETER_TYPE_LOCAL_TRANSFORM_NAME, value: DataCollectionConstants.NS_LOCAL_TRANSFORM},
			],
			onValueChange: function() {
				if (this.type === DataCollectionConstants.NS_LOCAL_TRANSFORM) {
					if (this.data[DataCollectionConstants.NS_VALUE]) {
						delete this.data[DataCollectionConstants.NS_VALUE];
					}
					
					if (!this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM]) {
						this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM] = [{}];
						this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM][0]["type"] = "literal"; //$NON-NLS-1$ //$NON-NLS-2$
					}
					this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM][0]["value"] = this.value; //$NON-NLS-1$
				} else {
					if (this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM]) {
						delete this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM];
					}
					
					if (!this.data[DataCollectionConstants.NS_VALUE]) {
						this.data[DataCollectionConstants.NS_VALUE] = [{}];
						this.data[DataCollectionConstants.NS_VALUE][0]["type"] = "literal"; //$NON-NLS-1$ //$NON-NLS-2$
					}
					this.data[DataCollectionConstants.NS_VALUE][0]["value"] = this.value; //$NON-NLS-1$
				}
				_self.data.status = ResourceHelper.calculateStatus(_self.data.status, DataCollectionConstants.STATUS_UPDATE);
			},
			onTypeChange: function() {
				if (this.type === DataCollectionConstants.NS_LOCAL_TRANSFORM) {
					if (this.data[DataCollectionConstants.NS_VALUE]) {
						delete this.data[DataCollectionConstants.NS_VALUE];
					}
					
					if (!this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM]) {
						this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM] = [{}];
						this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM][0]["type"] = "literal"; //$NON-NLS-1$ //$NON-NLS-2$
					}
					this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM][0]["value"] = this.value; //$NON-NLS-1$
				} else {
					if (this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM]) {
						delete this.data[DataCollectionConstants.NS_LOCAL_TRANSFORM];
					}
					
					if (!this.data[DataCollectionConstants.NS_VALUE]) {
						this.data[DataCollectionConstants.NS_VALUE] = [{}];
						this.data[DataCollectionConstants.NS_VALUE][0]["type"] = "literal"; //$NON-NLS-1$ //$NON-NLS-2$
					}
					this.data[DataCollectionConstants.NS_VALUE][0]["value"] = this.value; //$NON-NLS-1$
				}
				_self.data.status = ResourceHelper.calculateStatus(_self.data.status, DataCollectionConstants.STATUS_UPDATE);
			},
			onNameChange: function() {
				this.data[DataCollectionConstants.NS_NAME][0]["value"] = this.name; //$NON-NLS-1$
				_self.data.status = ResourceHelper.calculateStatus(_self.data.status, DataCollectionConstants.STATUS_UPDATE);
			}
		});
		parameterWidget.toggleEditMode(true);
		this.parameters.push(parameterWidget);
		this._parametersTable.appendChild(parameterWidget.domNode);
		this.setChange();
	},
	
	_onCollapseButtonClick: function(evt) {
		this.inherited(arguments);
		this.controller.layoutSections(this);
	},
	
	removeItem: function(item) {
		this.data.status = ResourceHelper.calculateStatus(this.data.status, DataCollectionConstants.STATUS_UPDATE);
		this.parameters.splice(dojo.indexOf(this.parameters, item), 1);
		var parameter = item.data;
		this.getWorkingCopy().removeParameter(this.data, parameter);
		item.destroyRecursive();
		this.setChange();
	},
	
	getWorkingCopy: function() {
		return this.controller.getWorkingCopy();
	},
		
	setChange: function() {
		this.controller.setChange();
	},
	
	uninitialize: function(){
		this.inherited(arguments);
	}
});

})();