/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.rational.datacollection.web.ui.internal.editors.ScheduleDialog"); //$NON-NLS-1$

	dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
	dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.ScheduleEditor"); //$NON-NLS-1$
	
	dojo.require('dojo.i18n'); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "ScheduleDialogMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	var ScheduleEditor = com.ibm.rational.datacollection.web.ui.internal.editors.ScheduleEditor;

	dojo.declare('com.ibm.rational.datacollection.web.ui.internal.editors.ScheduleDialog', [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
				
		widgetsInTemplate: true,
		messages: dojo.i18n.getLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "ScheduleDialogMessages"), //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.rational.datacollection.web", "ui/internal/editors/templates/ScheduleDialog.html"), //$NON-NLS-1$
		
		scheduleEditor: null,
		
		schedule: null,
								
		constructor: function(args){
			this.schedule = args.schedule;
			this.onOk = args.onOk;
			this.onCancel = args.onCancel;
		},
		
		postCreate: function(){
			this.inherited(arguments);
			this._dialog.setTitle(this.messages.dialogTitle);
			this.scheduleEditor = new ScheduleEditor(this.schedule);
			this.content.appendChild(this.scheduleEditor.domNode);
			
			this.connect(this.okButton, "onclick", dojo.hitch(this, function() { //$NON-NLS-1$
				var error = this.scheduleEditor.validate();
				if (!error) {
					this.onOk();
					this._dialog.close();
				}
			}));
			
			this.connect(this.cancelButton, "onclick", dojo.hitch(this, function() { //$NON-NLS-1$
				if (this.onCancel) {
					this.onCancel();
				}
				this._dialog.close();
			}));

		},
		
		getSchedule: function(originalSchedule) {
			return this.scheduleEditor.getSchedule(originalSchedule);
		},
		
		onClose: function(){
			this.inherited(arguments);
		},		
		
		onOk: null,
		
		onCancel : null
		
	});
})();
