/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.rational.datacollection.web.ui.internal.editors.Section"); //$NON-NLS-1$
	dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$
	dojo.require("jazz.ui.Menu"); //$NON-NLS-1$
	dojo.require("dojox.uuid.generateTimeBasedUuid"); //$NON-NLS-1$
	dojo.require("dojox.uuid.Uuid"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "SectionMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	dojo.declare("com.ibm.rational.datacollection.web.ui.internal.editors.Section", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.rational.datacollection.web", "ui/internal/editors/templates/Section.html"), //$NON-NLS-1$ //$NON-NLS-2$
		
		constructor: function(args) {
			this._sectionTwistieOpenIconSrc = dojo.moduleUrl("com.ibm.rational.datacollection.web", "graphics/icons/twistie-open.gif"); //$NON-NLS-1$ //$NON-NLS-2$
						
			if (!args) {
				return;
			}
			this.messages = dojo.i18n.getLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "SectionMessages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this.inherited(arguments);
			this.setTitle(this.getTitle());
		},
		
		getTitle: function() {
		},
		
		setTitle: function(title) {
			this.titleArea.innerHTML = title;
		},
		
		onAdd: function() {
		},
		
		isViewOnly: function() {
		},
		
		_onCollapseButtonClick: function(evt) {
			if (dojo.hasClass(this.contentArea, "hide")) { //$NON-NLS-1$
				this.collapseImage.src = dojo.moduleUrl("com.ibm.rational.datacollection.web", "graphics/icons/twistie-open.gif"); //$NON-NLS-1$  //$NON-NLS-2$
				this.collapseArea.title = this.messages.SectionHTML_0;
			} else {
				this.collapseImage.src = dojo.moduleUrl("com.ibm.rational.datacollection.web", "graphics/icons/twistie-closed.gif"); //$NON-NLS-1$  //$NON-NLS-2$
				this.collapseArea.title = this.messages.SectionHTML_1;
			}
			dojo.toggleClass(this.contentArea, "hide"); //$NON-NLS-1$
			dojo.stopEvent(evt);
		},
		
		collapsePanel: function(){
			this.collapseImage.src = dojo.moduleUrl("com.ibm.rational.datacollection.web", "graphics/icons/twistie-closed.gif"); //$NON-NLS-1$  //$NON-NLS-2$
			this.collapseArea.title = this.messages.SectionHTML_1;
			dojo.toggleClass(this.contentArea, "hide", true); //$NON-NLS-1$
		},
		
		_previewMode: function() {
			// hide this section if it has no visible field
			if (this._canHideInPreview()) {
				dojo.toggleClass(this.sectionArea, "hide", true); //$NON-NLS-1$			
			} else {
				dojo.toggleClass(this.editBar, "hide", true); //$NON-NLS-1$			
				dojo.toggleClass(this.domNode, "preview", true); //$NON-NLS-1$		
	
				// hide section title if it is empty
				if(!this.titleArea.value || dojo.string.trim(this.titleArea.value).lenth == 0) {
					dojo.toggleClass(this.headerSection, "hide", true); //$NON-NLS-1$
				}
			}
			
			this.titleArea.set('disabled', true); //$NON-NLS-1$
		},
		
		_editMode: function() {
			dojo.toggleClass(this.domNode, "preview", false); //$NON-NLS-1$
			dojo.toggleClass(this.headerSection, "hide", false); //$NON-NLS-1$			
			dojo.toggleClass(this.sectionArea, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.editBar, "hide", false); //$NON-NLS-1$
			this.titleArea.set('disabled', false); //$NON-NLS-1$
		},
		
		_onAddLinkClick: function(evt) {
			dojo.stopEvent(evt);
			this.onAdd();
		},
		
		_setChange: function() {
			this.controller._setChange();
		},
		
		doCommit: function() {
			dojo.forEach(this.fields, function(field) {
				field.doCommit();
			});
		},
				
		uninitialize: function() {
			dojo.forEach(this.fields, function(field) {
				field.destroyRecursive();
			}, this);
			
			this.inherited(arguments);
		}
	});
	
})();
