/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.rational.datacollection.web.ui.internal.editors.ValidatingTextBox"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

(function() {

dojo.declare("com.ibm.rational.datacollection.web.ui.internal.editors.ValidatingTextBox",[ dijit._Widget, dijit._Templated ], { //$NON-NLS-1$
	
	templatePath: dojo.moduleUrl("com.ibm.rational.datacollection.web", "ui/internal/editors/templates/ValidatingTextBox.html"), //$NON-NLS-2$ //$NON-NLS-1$
	
	constructor : function() {
	},
	
	postCreate : function() {
		this._errIcon = document.createElement("img"); //$NON-NLS-1$
		this._errIcon.className = "errIcon"; //$NON-NLS-1$
		this._errIcon.src = dojo.moduleUrl("com.ibm.rational.datacollection.web", "graphics/icons/inline-error.gif"); //$NON-NLS-2$ //$NON-NLS-1$
		this._errIcon.style.visibility = "hidden"; //$NON-NLS-1$
		this._container.appendChild(this._errIcon);
		this.inputNode = this._createInputNode();
		this._container.appendChild(this.inputNode);
		this._invalidValueMsg = document.createElement("span"); //$NON-NLS-1$
		this._invalidValueMsg.className = "invalidMsg"; //$NON-NLS-1$
		this._container.appendChild(this._invalidValueMsg);
		this.connect(this.inputNode, "onkeyup", function(e) { //$NON-NLS-1$
			this._handleKeyUp(e);
		});
	},
	
	setErrorMessage : function(message) {
		this._errorMessage = message;
	},
	
	isValid : function(){
		return !this._invalid;
	},
	
	_createInputNode : function() {
		var node;
		node = document.createElement("input"); //$NON-NLS-1$
		node._propertyElement = this;
		node.type = "text"; //$NON-NLS-1$
		node.value = this._currentValue ? this._currentValue : ""; //$NON-NLS-1$
	
		return node;
	},
	
	_checkValidity : function() {
		if (this.validate(this.inputNode.value) == true) {
			this._markValid();
		} else {
			this._markInvalid("error"); //$NON-NLS-1$
		}
	},
	
	_markValid : function() {
		while (this._invalidValueMsg.childNodes.length > 0) {
			this._invalidValueMsg
					.removeChild(this._invalidValueMsg.firstChild);
		}
		this._errIcon.style.display = ""; //$NON-NLS-1$
		this._errIcon.style.visibility = "hidden"; //$NON-NLS-1$
		this._invalid = false;
	},
	
	_markInvalid : function() {
		this._invalid = true;
		while (this._invalidValueMsg.childNodes.length > 0) {
			this._invalidValueMsg
					.removeChild(this._invalidValueMsg.firstChild);
		}
	
		if (this._errorMessage) {
			this._invalidValueMsg.appendChild(document
					.createTextNode(this._errorMessage));
		}
		this._invalidValueMsg.className = "invalidMsg"; //$NON-NLS-1$
		this._errIcon.style.visibility = "visible"; //$NON-NLS-1$
	},
	
	_handleKeyUp : function(e) {
		if (e.target && e.target.tagName === "INPUT") { //$NON-NLS-1$
			if (this.onKeyUpTimout) {
				clearTimeout(this.onKeyUpTimout);
			}
			var f = dojo.hitch(this, function() {
				this._checkValidity();
			});
			var timeout = 500;
	
			this.onKeyUpTimout = setTimeout(f, timeout);
		}
	}
});

})();