/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.rational.datacollection.web.ui.internal.pages.Application"); //$NON-NLS-1$
	dojo.require("com.ibm.team.app.web.RepositoryApplication"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.contextRoot"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.rational.datacollection.web.ui.internal.pages", "ApplicationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

	var messages = dojo.i18n.getLocalization("com.ibm.rational.datacollection.web.ui.internal.pages", "ApplicationMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	var URLPrefix = document.location.host + net.jazz.ajax.contextRoot();
	
	dojo.declare("com.ibm.rational.datacollection.web.ui.internal.pages.Application", com.ibm.team.app.web.RepositoryApplication, { //$NON-NLS-1$
		name: dojo.string.substitute(messages.Application_0, [URLPrefix]), //$NON-NLS-1$ //$NON-NLS-2$
		iconLarge: dojo.moduleUrl("com.ibm.rational.datacollection.web", "graphics/DCC_24.png"), //$NON-NLS-1$ //$NON-NLS-2$
		iconSmall: dojo.moduleUrl("com.ibm.rational.datacollection.web", "graphics/DCC_16.png"), //$NON-NLS-1$ //$NON-NLS-2$
		
		constructor: function() {
			this.ui.set("bannerTitle", messages.Application_1); //$NON-NLS-1$
		},
		
		initContext: function() {
			jazz.app.auth.setLogoutUrl(net.jazz.ajax.contextRoot() + "/auth/logout"); //$NON-NLS-1$
			this.start();
		}
		
	});
})();
