/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.extension.RequirementsSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.core.loader");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");

dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient");
dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementSelectionDialog");
dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView");

dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.extension.RequirementAssociationSourceSelectionDialog");
dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementExplorer");

dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementConnectClient");
dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementPackageClient");

dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.requirement.ReqProRequirementTablePanel");
dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementItemClient");

dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementProjectClient");

dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.ReqProServerClient");

dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.NewItemPopup");

dojo.require("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");

dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.requirement.ReqProSaveParticipant");

dojo.require("com.ibm.rqm.defects.web.ui.utils.CollectionLinksUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.client.internal.option");

(function(){ // module container
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var Utility = com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var AbstractArtifactEditorSection = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
    var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
    var DefectsUIUtil = com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil;
    
    
    var RequirementWorkItemClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient;
    var RequirementTableView = com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView;
    
    var RequirementConnectClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementConnectClient;
	var RequirementPackageClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementPackageClient;
	var RequirementItemClient    = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementItemClient;

	var RequirementProjectClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementProjectClient;
    var ReqProServerClient       = com.ibm.rqm.requirement.web.client.internal.requirement.ReqProServerClient;
    
    var PlanningClient 			 = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
    var AlertDialog              = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
    
    var REQ_WORKITEM_TYPE_ID = "requirement";
    
    var getCurrentProjectArea = jazz.app.context.get;
    var CollectionLinksUtil = com.ibm.rqm.defects.web.ui.utils.CollectionLinksUtil;
    var KEY = Constants.REQUIREMENT_RISK_PREFERENCE;
    
    dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.extension.RequirementsSection", [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {
        templateString: '<div class="com-ibm-rqm-test-requirement-plan-section">' +
                        '   <div dojoAttachPoint="_tableContainer"></div>' +
                        '</div>',
        
        REQPRO: "labelRequirementsReqPro",
        DOORS: "labelDOORS",
        currentTable: "labelRequirementsReqPro",
        requirementTables: ["labelRequirementsReqPro", "labelDOORS"],
        
        reqproTable: null,
       	doorsTable: null,
       	
       	currentReqProConnection: null,
       	currentReqProConnectionId: null,
       	currentReqProProjectId: null,
       	currentReqProProjectName: null,
       	
       	REFERENCE_ID: "artifactItemId",
       	
       	reqproSaveParticipant: null,
       	
       	reqSummaryAsName: DefectsUIUtil.getMessage("labelUseReqSummary"),
       	
       	hasParentTestPlans: false,
        
        // allows a small subset of actions when the section isn't hosted in
        // an editor context.
        minimumActions: false,
        
		currentParentTestPlans: [],
		
        constructor: function(args){
            this.RequirementWorkItemClient = RequirementWorkItemClient;
            this._reqTableViewer = null;
        },
        
        postCreate: function(){
            this.inherited('postCreate', arguments);
            
            this.disableRiskColumn = true;
            this._newAddedReqProRequirements = [];
        	this._removedReqProRequirements = [];
        	this._reqproItems = [];
            this.hasParentTestPlans = false;
            this.addWorkItemSupport();
			this.requirementTables = ["labelRequirementsReqPro", "labelDOORS"];
			

			
			//if this is a copy, must force initialization in order to create new links
			if (this.getParentEditor().isCopy()) {
				this.initialize(this.isEditable());
			}			
        },
        
        // @Overriden from AbstractArtifactEditorSection - the requirement section
        // can be used in non-editor context. If the parent editor doesn't have
        // section define, don't call the superclass's handling.
        refreshSection: function() {
            if(this.parentEditor.getArtifactSection) {
                this.inherited(arguments);
            }
        },
        
        //@Overriden from AbstractArtifactEditorSection
        initialize: function(isEditable){
            
            //re-init the attributes
            this._requirements = [];
            this._requirementsAdded = [];
            this._requirementsRemoved = [];
            this._newAddedReqProRequirements = [];
        	this._removedReqProRequirements = [];
        	this._reqproItems = [];
            
            if(this._reqTableViewer && dojo.isFunction(this._reqTableViewer.destroyRecursive)){
            	this._reqTableViewer.destroyRecursive();
            	this._reqTableViewer = null;
            	this.doorsTable = null;
            }else{
            	this._reqTableViewer = null;
            	this.doorsTable = null;
            }
            
            if(this.reqproTable && dojo.isFunction(this.reqproTable.destroyRecursive)){
            	this.reqproTable.destroyRecursive();
            	this.reqproTable = null
            }else{
            	this.reqproTable = null;
            }

            if (this.getArtifactType() == Constants.TYPE_PLAN) {
                this._linkType = "com.ibm.rqm.requirement.linkType.testPlan";
            }
            else {
                this._linkType = "com.ibm.rqm.requirement.linkType.testCase";
            }
            
            this.showRequirementList();
			this.initialized = true;
        },

        clearReqProSaveParticipants: function(){
			
			var context = this.getSaveContext();			
			var participant = this.reqproSaveParticipant;
			
			if (participant) {
				context.uncreateReference(participant, this.REFERENCE_ID, this.getParentEditor());
				context.removeParticipant(participant);				
				delete this.reqproSaveParticipant;
			}
						
			this._newAddedReqProRequirements = [];
			this._removedReqProRequirements = [];
			
						
        },
        
        
        //@Overridden from AbstractArtifactEditorSection
        saveFinished: function(savedItem){
            this.inherited('saveFinished', arguments);
            this.clearReqProSaveParticipants();
            
            // we need to retain the selection in the table for the
            // user after save. Get the current selected rows before
            // we refresh, and we'll set them to be selected when
            // get refreshed the list.
            if(this._retainSelection && this._reqTableViewer) {
                var rows = this._reqTableViewer.getSelectedRows();
                if(rows && dojo.isArray(rows) && rows.length) {
                    this.selectedRows = rows;
                }
                delete this._retainSelection;
            }
            // if we have not been shown, don't need to
            // create the content
            if (this.initialized) {
                this.initialize();
            }
            this.addWorkItemSupport();
            if (this._reqTableViewer) {
                this._reqTableViewer.setEditable(this.isEditable() && this.getArtifact());
            }
			this._requirementsAdded = [];
            this._requirementsRemoved = [];
			
			//if row selection will be cleared reset all the actions need to be disabled without row select
			if(!this._retainSelection && this.reqproTable){
				//delete requirement action
				if(this.reqproTable.deleteActionNode){
					this.reqproTable.deleteActionNode.setDisabled(true);
				}
				//create test case from requirement action
				if(this.reqproTable.createTestCaseActionNode){
					this.reqproTable.createTestCaseActionNode.setDisabled(true);
				}
				//sync requirement action
				if(this.reqproTable.syncLinkActionNode){
					this.reqproTable.syncLinkActionNode.setDisabled(true);
				}
				//find Associated TestCase action
				if(this.reqproTable.findAssociatedTestCaseActionNode){
					this.reqproTable.findAssociatedTestCaseActionNode.setDisabled(true);
				}
			}				
        },
        
        //actions to be displayed in the table header
        getTableActions: function(){
            var actions = [];     
            
            var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_REQ_WORKITEM); 
            
            if(this.currentTable == this.REQPRO){
            	actions.push({
                	label: Constants.getMessage("labelRefresh"),
                	actionHandler: dojo.hitch(this, "_handleRefreshReqProLinksClicked"),
                	iconClass: "refresh-icon-image",
               	 	disabledOnReadOnly: true
            	});
            }
                  
            if (!this.minimumActions && this.getArtifactType() == Constants.TYPE_PLAN) {
				//add "create test cases" button
				var tcPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE);
				if (!tcPerm || tcPerm.create) {
					actions.push({
						label: Constants.getMessage("labelCreateTestCases"),
						actionHandler: dojo.hitch(this, "_handleCreateTestCases"),
						iconClass: "add-new-testcase-image",
						disabledOnReadOnly: true
					});
				}

            }
            if(!this.minimumActions && ((!permission || permission[PermissionsClient.ACTION_IMPORT]) && ((this.currentTable != this.DOORS) || (this.getArtifactType() == Constants.TYPE_CASE)))){
            	actions.push({
                	label: Constants.getMessage("labelAssociateRequirements"),
               	 	actionHandler: dojo.hitch(this, "_handleAssociateRequirementClicked"),
                	iconClass: "add-icon-image",
                	disabledOnReadOnly: true
            	});
            } 
            
			if(!this.minimumActions && (!permission || permission[PermissionsClient.ACTION_ARCHIVE])){
            	actions.push({
                label: Constants.getMessage("labelDisassociateRequirements"),
                actionHandler: dojo.hitch(this, "_handleRemoveRequirementClicked"),
                iconClass: "remove-reqirement-image",
                disabledOnReadOnly: true
            });
            } 
            
			
			if(!this.minimumActions && (this.currentTable == this.REQPRO && (!permission || permission[PermissionsClient.ACTION_CHANGE_STATUS]))){
				actions.push({
	            	label: Constants.getMessage("labelSyncReq"),
	            	actionHandler: dojo.hitch(this, function(){
						jazz.core.loader.load_async("com.ibm.rqm.defects.web.ui.internal.wizard.ReqProRequirementSyncWizard", dojo.hitch(this, "_invokeSyncWizard"));
					}),
	            	iconClass: "sychronize-icon-image",
	            	disabledOnReadOnly: true
	            });
			}
			
            if (!this.minimumActions && this.getArtifactType() == Constants.TYPE_PLAN) {
                actions.push({
	                label: Constants.getMessage("labelAssociatedTestCases"),
	                actionHandler: dojo.hitch(this, "_handleFindAssociatedTestCaseClicked"),
	                iconClass: "tcases-w-requirmt-icon-image",
	                disabledOnReadOnly: true
            	});
            }
            
            return actions;
        },
		
		_invokeSyncWizard: function(items) {
            var reqProItems = this.reqproTable.getCheckedRows();
            var artifact = this.getArtifact();
			var artifactType = this.getArtifactType();
            if (!artifact || reqProItems.length == 0) {
                return;
            }
            // since we're potentially going to modify the parent test plan with this action
            // and load the modified test plan to the parent editor, we need to ask the user
            // to save any unsaved changes first to ensure that the user wouldn't lose any
            // work. 
            var parentEditor = this.getParentEditor();
            if(parentEditor.isDirty()) {
                var dialog = new AlertDialog({
                    primaryTitle:  Constants.getMessage("titleSyncReq"),
                    message: Constants.getMessage("msgSaveArtifactBeforeSyncReq")
                });
                dialog.open();
                
                // remember the selection when we update the list
                // due to save
                this._retainSelection = true;
                return;
            }
            var self = this;
            var wizard = new com.ibm.rqm.defects.web.ui.internal.wizard.ReqProRequirementSyncWizard({
                reqProItems: reqProItems,
                artifact: artifact,
				artifactType: artifactType,
                onOk: dojo.hitch(self, function(){
					//this.setDirty(true);
				}),
				//TODO:
                changeTestCaseSuspectState: dojo.hitch(self, "_changeTestCaseSuspectState"),
				acceptChangeAndSuspectTC: dojo.hitch(this, "_acceptChangeAndSuspectTC")                        
            });
            wizard.open();
        },
		
		_changeTestCaseSuspectState: function(monitor, links, tcItemIds){
			jazz.core.loader.load_async("com.ibm.rqm.defects.web.ui.utils.CollectionLinksUtil", dojo.hitch(this, function(){
				var msg = tcItemIds.length > 1 ? DefectsUIUtil.getMessage("msgChangingTCsSuspect", tcItemIds.length) : DefectsUIUtil.getMessage("msgChangingTCSuspect");
				var msg2 = tcItemIds.length > 1 ? DefectsUIUtil.getMessage("msgChangedTCsSuspect", tcItemIds.length) : DefectsUIUtil.getMessage("msgChangedTCSuspect");
				var msg3 = tcItemIds.length > 1 ? DefectsUIUtil.getMessage("msgFailChangeTCsSuspect", tcItemIds.length) : DefectsUIUtil.getMessage("msgFailChangeTCSuspect");
				var taskId = msg + new Date().toString();
				monitor.beginTask(msg, taskId);
				com.ibm.rqm.defects.web.ui.utils.CollectionLinksUtil.changeTestCaseSuspectState(links, tcItemIds, dojo.hitch(this, function(testCases){
	                    monitor.done(testCases, taskId, msg2);
	                    dojo.publish(GlobalEvents.ArtifactsUpdated ,[Constants.SUSPECT_TYPE, testCases]);
					}), dojo.hitch(this, function(e){
						monitor.done(tcItemIds, taskId, msg3, e);
				}));
			}));
        },
		
		/**
		 * 
		 * @param {Object} monitor
		 * @param {Object} requirements
		 * @param {Object} tcItemIds
		 * @param {Object} action
		 * @param {Object} suspect  true to suspect test case, false to not suspect. false as default.
		 */
		_acceptChangeAndSuspectTC: function(monitor, requirements, tcItemIds, action, suspect){
			
			jazz.core.loader.load_async("com.ibm.rqm.defects.web.ui.utils.CollectionLinksUtil", dojo.hitch(this, function(){
				monitor._dialog.getOkButton().disabled = true;
				var msg = "";
				var msg2 = "";
				var msg3 = "";
				if(action == "update"){
					msg = requirements.length > 1 ? Constants.getMessage("msgAcceptingReqsChanges", requirements.length) : Constants.getMessage("msgAcceptingReqChanges");
					msg2 = requirements.length > 1 ? Constants.getMessage("msgAcceptedReqsChanges", requirements.length) : Constants.getMessage("msgAcceptedReqChanges");
					msg3 = requirements.length > 1 ? Constants.getMessage("msgFailAcceptReqsChanges", requirements.length) : Constants.getMessage("msgFailAcceptReqChanges");
				}else if(action == "remove"){
					msg = requirements.length > 1 ? Constants.getMessage("msgRemoveReqs", requirements.length) : Constants.getMessage("msgRemoveReq");
					msg2 = requirements.length > 1 ? Constants.getMessage("msgRemovedReqs", requirements.length) : Constants.getMessage("msgRemovedReq");
					msg3 = requirements.length > 1 ? Constants.getMessage("msgFailRemovReqs", requirements.length) : Constants.getMessage("msgFailRemovReq");
				}
				var taskId = msg + new Date().toString();
				monitor.beginTask(msg, taskId);
				//1. Accept ReqPro requirements changes
				var args = {};
				var parentEditor = this.getParentEditor();
				if(parentEditor.getArtifactType() == Constants.TYPE_PLAN){
					args.vtestPlanItemId = this.getArtifact().versionableItemId;
				} else if(parentEditor.getArtifactType() == Constants.TYPE_CASE){
					args.vtestCaseItemId = this.getArtifact().versionableItemId;
				}
			  	com.ibm.rqm.defects.web.ui.utils.CollectionLinksUtil.persistReqProRequirementChange(requirements, args, dojo.hitch(this, function(persistedReqs){
						monitor.done(requirements, taskId, msg2);
						// 2. Suspect test cases
						if(tcItemIds.length && suspect)
							this._changeTestCaseSuspectState(monitor, requirements, tcItemIds);
						// 3. Refresh the requirement table
						this._reLoadReqProTable();
						monitor._dialog.getOkButton().disabled = false;
				}), dojo.hitch(this, function(e){
					monitor.done(requirements, taskId, msg3, e);
					console.debug(e);
					monitor._dialog.getOkButton().disabled = false;
				}), action);
			}));
		},
		
		doShowDoorsRequirementList: function(){
			if (!this._reqTableViewer) {
                //dojox.xml.parser.removeChildren(this._tableContainer);
                dojox.xml.parser.removeChildren(this.tableDiv);
                var args = {
                    requirements: this._requirements,
                    editable: this.isEditable(),
                    actions: this.getTableActions(),
                    parent: this,
					printable: this.isPrintView(),
                    contentIsVirtual: false,
                    tableId: this.tableId,
                    minimumActions: this.minimumActions,
                    
                    // the table have actions to update the requirement's statuses,
                    // need to get our copy refreshed as well.
                    onStatusRefreshed: dojo.hitch(this, function(requirements) {
                        this._requirements = requirements;
                    }),
					refreshCallback: dojo.hitch(this, "_loadRequirements"),
					showDuplicateAction: false,
					section: this,
					disableRiskColumn: this.disableRiskColumn
                };
                this._reqTableViewer = new RequirementTableView(args);
                //this._tableContainer.appendChild(this._reqTableViewer.domNode);
                this.tableDiv.appendChild(this._reqTableViewer.domNode);
                this.doorsTable = this._reqTableViewer;
            }
            
            //load the table
            if (this.getArtifact()) {
                this._loadRequirements();
            }
		},
		
        showDoorsRequirementList: function(){

           	var option = new com.ibm.asq.common.web.client.internal.option();
        	var context = {
        		invoker: this,
        		success: function(response){
        			var values = response && response.value ? dojo.fromJson(response.value) : {enableRequirementRisk: false};
        			this.invoker.disableRiskColumn = !values.enableRequirementRisk;
        			this.invoker.doShowDoorsRequirementList();
        		},
        		
        		error: function(e){
        			this.invoker.disableRiskColumn = true;
        			this.invoker.doShowDoorsRequirementList();
        			console.error("retrieve requirement risk profile error.");
        		}
        	};
			var responsehandler = new ServiceResponseHandler(context, "success", "error")
			option.getProjectPreferences(responsehandler, getCurrentProjectArea().itemId, KEY);
        },
        
        _refreshRequirementList: function(requirements) {
			requirements = requirements || [];
			if (this.getParentEditor().isCopy() && !this._copyInitialized) {
				//for copied artifacts, add existing reqts (from copied artifact) as new links to new copuy 
				this.addRequirements(requirements);
				this._copyInitialized = true;
			} else {
				this._requirements = requirements;	
			}		
            
            this.refresh();			
        },
        
        _checkSelectedRowsExist: function(rows) {
            var len = rows.length;
            var list = [];
            for(var i = 0; i < len; i++) {
                var row = rows[i];
                if(this._contains(this._requirements, row)) {
                    list.push(row);
                }
            }
            return list;
        },
        
        refresh: function(){
            this._reqTableViewer.refresh(this._requirements);
            
            // we're retaining the selections for the user. Set the select
            // rows before we refresh the table's content.
            if(this.selectedRows) {
                var tableViewer = this._reqTableViewer.tableViewer;
                if (this._requirements && tableViewer) {
                    var rows = this._checkSelectedRowsExist(this.selectedRows);
                    if (rows.length > 0) {
                        tableViewer.selectRows(rows, true);
                    }
                }
                delete this.selectedRows;
            }
            if(this._reqTableViewer.disaccosiateButton){
				this._reqTableViewer.disaccosicateButton.setDisabled(true);
            }
			if(this._reqTableViewer.assoicatedTestPlanNode!=null)
				this._reqTableViewer.assoicatedTestPlanNode.setDisabled(true);
			if(this._reqTableViewer.assoicatedTestCaseNode!=null)
				this._reqTableViewer.assoicatedTestCaseNode.setDisabled(true);
			if(this._reqTableViewer.clearStatusActionNode!=null)
				this._reqTableViewer.clearStatusActionNode.setDisabled(true);	
		},
        
        _loadRequirements: function(){
            if (this.getArtifact() && this._reqTableViewer) {
                var responseHandler = new ServiceResponseHandler(this, "_refreshRequirementList", "_error");
                switch (this.getArtifactType()) {
                    case Constants.TYPE_PLAN:
                        this.RequirementWorkItemClient.getRequirementWorkItemDTOs(responseHandler, {
                            testPlanItemId: this.getArtifact().versionableItemId
                        });
                        break;
                    case Constants.TYPE_CASE:
                        this.RequirementWorkItemClient.getRequirementWorkItemDTOs(responseHandler, {
                            testCaseItemId: this.getArtifact().versionableItemId
                        });
                        break;
                }
            }
            else {
                //this.RequirementWorkItemClient.getAllRequirements(this, callbackFunction);
            }
        },
        
        _handleAssociateRequirementClicked: function(){
        	if(this.currentTable == this.REQPRO){
        		this._handleAssociateReqProRequirementClicked();
        	}else{
				this._createDoorsAssociationDialog();
        	}
        },
        
        _createDoorsAssociationDialog:function(){
        	var self = this;
            var dialogArgs = {
                object: this,
                // the selection dialog will filter req related to this item.
                // Pass in the items just added as disabled items. The user would
                // not be able to select these again.
                disabledItems: this._requirementsAdded,
                removedReqs:this._requirementsRemoved,
                type: this.getArtifactType(),
                artifactId: this.getArtifact()? this.getArtifact().versionableItemId : null,
                onOK: function(requirements){
                   if(self.getArtifactType() == Constants.TYPE_PLAN){
						var args = {
							primaryTitle: Constants.getMessage("labelConfirmation"),
							message: Constants.getMessage("msgConfirmSaveRelatedTC"),
							yesCallback: function() {
								self.addRequirements(requirements, true);
							},
                			noCallback: function() {
                				self.addRequirements(requirements);
                			}
						}						
						var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
                		dialog.open();
					} else {
						self.addRequirements(requirements);	
					}                    
                }
            }
            this.requirementDialog = new com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementSelectionDialog(dialogArgs);
			
			var args = {
                primaryTitle: Constants.getMessage("labelAssociateRequirement"),
                // make our z index below that of a popup tooltip. Otherwise,
                // our dialog will cover the tooltip popups
                zIndex: 998,
                forceZIndex: true,
                isClosable: true,
                contentNode: this.requirementDialog.domNode,
                
                _yesAction: function(){
                    // override the button action to not close the
                    // dialog immediately. the base impl does check for
                    // return value to not popdown the dialog, but it
                    // will re-enable the yes button.
                    this._yesButton.disabled = true;
                    this.okCallback();
                },                
				okCallback: dojo.hitch(this.requirementDialog, "_onOK")
            }
            this.floatingPane = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(args);
			this.floatingPane._yesButton.disabled = false;
            dojox.xml.parser.removeChildren(this.floatingPane._headerText);
            var span1 = document.createElement("span");
            span1.innerHTML = Constants.getMessage("labelAssociateRequirement");
            this.floatingPane._headerText.appendChild(span1);
            
            this.floatingPane.open(false);
            this.floatingPane.domNode.style.width = "76em";
            this.requirementDialog._dialog = this.floatingPane;
			this.requirementDialog.initialize();
        },
                
        _handleRemoveRequirementClicked: function(){
        	
        	var selectedRequirements = [];
        	
        	if(this.currentTable == this.REQPRO){
        		selectedRequirements = this.reqproTable.getSelectedRows();
        	}else{
        		selectedRequirements = this._reqTableViewer.getSelectedRows();
        	}
        	
            
            if (selectedRequirements && selectedRequirements.length > 0) {
				var len = selectedRequirements.length;
                var promptMsg = len > 1 ? "msgConfirmDeleteRequirements" : "msgConfirmDeleteOneRequirements";
				var self = this;
				var args = {
					primaryTitle: Constants.getMessage("labelConfirmation"),
					message: Constants.getMessage(promptMsg,len),
					yesCallback: function(){   
						console.debug("Number of to be removed - " + len);
						if(self.currentTable == self.REQPRO){
							self.removeReqProRequirementsOnUI(selectedRequirements);
						}else{
                			self.removeRequirements(selectedRequirements);
						}
						return true;          
					},
					noCallback: function() {
						return false;
					}
				}
				var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
	        	dialog.open();
            }
            else {
                this.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("msgNoRequirementDisassociate"));
            }
        },

        _handleFindAssociatedTestCaseClicked: function() {
        	
        	var selectedReqs = [];
        	
        	if(this.currentTable == this.REQPRO){
        		selectedReqs = this.reqproTable.getSelectedRows();
        	}else{
        		selectedReqs = this._reqTableViewer.getSelectedRows();
        	}
        	
			if(!selectedReqs || selectedReqs.length != 1) {
				return;
			}
			var selectedReq = selectedReqs[0];
			var args = {};
			args.subAction = "viewAssociatedTestCases";
			if(this.currentTable == this.REQPRO){
				args.itemId = selectedReq.itemId;
				args.id = selectedReq.srcId;
				args.name = selectedReq.name;
				args.isForReqPro = true;	
			}else{
				args.itemId = selectedReq.itemId;
				args.id = selectedReq.id;
				args.name = selectedReq.name;
			}
			args.testPlanItemId = this.getArtifact().versionableItemId;
			var uri = "#action=com.ibm.rqm.planning.home.actionDispatcher"; //FIXME removed hard coded action dispatcher id
                
            for(var argName in args) {
                var argVal = args[argName];
                
                if(argName == "tq")
                    argVal = Date.parse(new Date().toString());
                    
                uri += ("&" + argName + "=" + argVal); 
            }
            window.location.hash = uri;
        }, 
		
		_handleCreateTestCases: function() {
			
			var selectedReqs = null;
			var isReqPro = false;
			
			if(this.currentTable == this.REQPRO){
				selectedReqs = this.reqproTable.getSelectedRows();
				isReqPro = true;
			}else{
            	selectedReqs = this._reqTableViewer.getSelectedRows();
			}
            
            if (!selectedReqs) {
                return;
            }
            
            // since we're potentially going to modify the parent test plan with this action
            // and load the modified test plan to the parent editor, we need to ask the user
            // to save any unsaved changes first to ensure that the user wouldn't lose any
            // work. 
            var parentEditor = this.getParentEditor();
            if(parentEditor.isDirty()) {
                var dialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({
                    primaryTitle:  Constants.getMessage("labelNewTestCase"),
                    message: Constants.getMessage("msgUnsavedChange")
                });
                dialog.open();
                
                // remember the selection when we update the list
                // due to save
                this._retainSelection = true;
                return;
            }
            
            var isReqProRequirement = (this.currentTable == this.REQPRO)

            var _self = this;
			
			var nameEditable = false;
			var defaultName = this.reqSummaryAsName;
			if(selectedReqs.length && selectedReqs.length == 1){
				nameEditable = true;
				defaultName = selectedReqs[0].name || selectedReqs[0].summary;
			}
			
            var newTCDialog = new com.ibm.rqm.planning.web.ui.internal.view.construction.NewItemPopup({
    			itemType:Constants.MODEL_TYPE_CASE,
    			nameEditable: nameEditable,
    			displayOwner:true,
    			defaultName: defaultName,
    			onOkCallback: function(){
    				if(isReqPro == true) {
    					_self.generateTestCases4ReqPro(selectedReqs, this.getAttributes());
    				} else {
    					_self.generateTestCases(selectedReqs, this.getAttributes());
    				}
    				
    			}    
    		}); 
            
		},
		
		
		generateTestCases4ReqPro: function(requirements, template){
            var testcases = [];
            var requirementsCount = requirements.length;
            var promptMsg = requirementsCount > 1 ? "msgCreatingTC" : "msgCreatingOneTC";
            
			var reqIds = [];
			var names = [];
			var ownerIds = [];
			var descriptions = [];
			var weights = [];
			var categories = [];
			var workItemsJsonStrings = [];
			var customAttributesJsons = [];
			
			dojo.forEach(requirements, dojo.hitch(this, function(requirement){
			  	reqIds.push(requirement.srcId);
			}));
			

			dojo.forEach(reqIds, function(id){
				ownerIds.push(template.ownerIds.length ? template.ownerIds[0] : "-1");
				workItemsJsonStrings.push("-1");
				descriptions.push(template.description);
				weights.push(template.weight);
				categories.push(template.categories);
				customAttributesJsons.push(template.customAttributesJson);
			});
			if (reqIds.length == 1) {
				names.push(template.name);
			}
			else {
				for (var i in reqIds) {
					// use requirement name as test case name. If requirement name is empty, then use requirement description
					names.push(requirements[i].name || requirements[i].description);
				}
			}
			
			var parameters = {
					isSingleTestCase: reqIds.length == 1,
					planId: this.getArtifact().id,
					ids: dojo.toJson(reqIds),
					names: dojo.toJson(names),
					ownerIds: dojo.toJson(ownerIds),
					descriptions: dojo.toJson(descriptions),
					weights: dojo.toJson(weights),
					categories: dojo.toJson(categories),
					workItemsJsonStrings: dojo.toJson(workItemsJsonStrings),
					customAttributesJsons: dojo.toJson(customAttributesJsons),
					templateItemId: template.templateItemId,
					templateStateId: template.templateStateId,
					processArea: getCurrentProjectArea().itemId,
					teamArea : this.getArtifact().teamArea
				};
               
            var handler = {
                success: dojo.hitch(this, function(createdTCs) {
               		var editor = this.getParentEditor();
               		
               		// the parent test plan has been modified on the server. Need to
               		// refresh the artifact to pick up the state id to avoid getting
               		// a stale data message when the user edit the test plan again.
               		// We can safely do this, since the editor must not be dirty before
               		// generating test cases.
               		if(editor._reloadEditor) {
               			editor._reloadEditor();
               		}
            		var message = createdTCs.length == 1 ? Constants.getMessage("labelTestCaseCreatedSuccess") : Constants.getMessage("labelTestCasesCreatedSuccess");
            		new AlertDialog({
            			message: message,
            			width: "30%"
            		}).open(true);
                }),
                error: dojo.hitch(this, function(e) {
					console.debug(e)
                })
            };
            
            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            RequirementWorkItemClient.postCreateTestCasesByReqProRequirement(responseHandler, parameters);

        },
        
        generateTestCases: function(requirements, template){
            var testcases = [];
            var requirementsCount = requirements.length;
            var promptMsg = requirementsCount > 1 ? "msgCreatingTC" : "msgCreatingOneTC";
            
			var reqIds = [];
			
			dojo.forEach(requirements, dojo.hitch(this, function(requirement){
			  	reqIds.push(requirement.id);
			}));

			var parameters = {
				isSingleTestCase: reqIds.length == 1,
				planId: this.getArtifact().id,
				ids: reqIds,
				names: [],
				ownerIds: [],
				descriptions: [],
				weights: [],
				categories: [],
				workItemsJsonStrings: [],
				customAttributesJsons:[],
				templateItemId: template.templateItemId,
				templateStateId: template.templateStateId,
				processArea: getCurrentProjectArea().itemId,
				teamArea : this.getArtifact().teamArea
			};
			dojo.forEach(reqIds, function(id){
				parameters.ownerIds.push(template.ownerIds.length ? template.ownerIds[0] : "-1");
				parameters.workItemsJsonStrings.push("-1");
				parameters.descriptions.push(template.description);
				parameters.weights.push(template.weight);
				parameters.categories.push(template.categories);
				parameters.customAttributesJsons.push(template.customAttributesJson);
			});
			if (reqIds.length == 1) {
				parameters.names.push(template.name);
			}
			else {
				for (var i in reqIds) {
					// use requirement name as test case name. If requirement name is empty, then use requirement description
					parameters.names.push(requirements[i].name || requirements[i].description);
				}
			}
               
            var handler = {
                success: dojo.hitch(this, function(createdTCs){
               		var editor = this.getParentEditor();
               		
               		// the parent test plan has been modified on the server. Need to
               		// refresh the artifact to pick up the state id to avoid getting
               		// a stale data message when the user edit the test plan again.
               		// We can safely do this, since the editor must not be dirty before
               		// generating test cases.
               		if(editor._reloadEditor) {
               			editor._reloadEditor();
               		}
                }),
                error: dojo.hitch(this, function(e){
					console.debug(e)
                })
            };
            
            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            RequirementWorkItemClient.postCreateTestCasesByRequirement(responseHandler, parameters);

        },
	
		openInNewTab: function(args){
            if (args && args.length > 1) {
				dojo.publish(GlobalEvents.TestCasesCreated, [ args ]);
            }
            else 
                if (args && args.length == 1) {
                    window.location.hash = "action=com.ibm.rqm.planning.home.actionDispatcher&subAction=viewTestCase&id=" + args[0].id;
                }
		},
        
        addRequirements: function(requirements, addRelatedTestCases){
			var len = requirements?requirements.length:0;
            var editor = this.getParentEditor();
			var reqtIds = [];
			for (var i = 0; i < len; i++) {
				var reqt = requirements[i];
                if (this._contains(this._requirementsRemoved, reqt)) {
                    this.getSaveContext().unremoveLink(editor, this._linkType, reqt.itemId);
                    this._requirementsRemoved = this._removeItem(this._requirementsRemoved, reqt);
                    this._requirements.push(reqt);
                
				} else if (!this._contains(this._requirements, reqt)) {
                    this.getSaveContext().createLink(editor, this._linkType, reqt.itemId);
                    this._requirementsAdded.push(reqt);
                    this._requirements.push(reqt);							
					reqtIds.push(reqt.itemId);
					
				} else {
                    editor.setHeaderStatus(Constants.getMessage("msgExistRequirement"), Constants.HEADER_STATUS_INFO);
                    this._displayAlertDialog(Constants.getMessage("labelAlert"), Constants.getMessage("msgExistRequirement"));
                }
            }
			
			if (addRelatedTestCases === true && reqtIds.length > 0) {
            	var responseHandler = new ServiceResponseHandler(this, "_addTestCases", "_error");
                var args = {
					itemIds: reqtIds
				}
				this.RequirementWorkItemClient.getTestCasesByRequirements(responseHandler, args);							
			}
								
            this.setDirty();
            this.refresh();
        },		
		
		_addTestCases: function(relatedCases){
			//ensure the parent editor contains the test case section
			var section = this.getParentEditor().getSection("com.ibm.rqm.planning.editor.section.planTestCases"); //$NON-NLS-1$
			if (section == null) {
				console.warn("Parent Editor does not contain the TestCases section."); //$NON-NLS-1$
				return;
			}
			//ensure we're only adding test cases that the section doesn't already contain
			var len = (relatedCases || []).length;
			for (var i = 0; i < len; i++) {
				var tCase = relatedCases[i];
				if (!section.containsTestCase(tCase)) {
					section.addTestCases([tCase]);
				}
			}
		},
        
        removeRequirements: function(requirements){
        	var msg = "";
        	var isDirty = false;
			var len = requirements?requirements.length:0;
            for (var i = 0; i < len; i++) {
            	// DOORS exported requirements are read-only, cannot remove from plan
            	if(typeof(requirements[i].externalId)!="undefined"&&requirements[i].externalId.match(/^doors\//i)&&this.getParentEditor().getArtifactType()==Constants.TYPE_PLAN) {
            		msg += Constants.getMessage("msgCannotRemoveReadOnlyRequirement", requirements[i].id) + "<br>";
            	}
            	else {
                	this._removeRequirement(requirements[i]);
                	isDirty = true;
                }
            }
            if(msg != ""){
            	var alertDialog = new AlertDialog({'message': msg});
	    	    alertDialog.setSecondaryTitle(Constants.getMessage("labelAlert"));
	        	alertDialog.open();
            }
            if (isDirty)
            	this.setDirty();
            this.refresh();
        },
        
        _contains: function(items, item){
            var id = item.id;
            var externalId = item.externalId;
            if (id) {
                return this._getRequirementById(items, id) != null;
            }
            else {
                return this._getRequirementByExternalId(items, externalId) != null;
            }
        },
        
        _getRequirementById: function(items, id){
			var len = items.length;
            for (var i = 0; i < len; i++) {
                var requirement = items[i];
                var itemId = requirement.id;
                if (itemId == id) {
                    return items[i];
                }
            }
            return null;
        },
        
        _getRequirementByExternalId: function(items, id){
			var len = items.length;
            for (var i = 0; i < len; i++) {
                var requirement = items[i];
                var itemId = requirement.externalId;
                if (itemId == id) {
                    return items[i];
                }
            }
            return null;
        },
        
        _removeRequirement: function(item){
            var updatedItems = [];
            var items = this._requirements;
			var len = items.length;
            for (var i = 0; i < len; i++) {
                if (items[i].itemId && items[i].itemId != item.itemId) {
                    updatedItems.push(items[i]);
                }
                else {
                    //handle item removal from save context   
                    var saveContext = this.getSaveContext();
                    if (this._contains(this._requirementsAdded, items[i])) {
                        //handle existing items ADDED during this saveContext session
                        this._requirementsAdded = this._removeItem(this._requirementsAdded, items[i]);
                        saveContext.uncreateLink(this.getParentEditor(), this._linkType, items[i].itemId);
                    }
                    else {
                        //handle existing references, add them 'removed'
                        this._requirementsRemoved.push(items[i]);
                        saveContext.removeLink(this.getParentEditor(), this._linkType, items[i].itemId);
                    }
                }
            }
            this._requirements = updatedItems;
        },
        
        _removeItem: function(items, item){
            var updatedArray = [];
			var len = items.length;
            for (var i = 0; i < len; i++) {
                if (items[i].itemId != item.itemId) {
                    updatedArray.push(items[i]);
                }
            }
            return updatedArray;
        },
        
        _associateRequirementsError: function(e){
        	if(this.requirementExplorer){
        		this.requirementExplorer._endAssociationProcess();
        	}
        	this._error(e);
        },
        
        _error: function(e){
            this._displayAlertDialog(Constants.getMessage("labelError"), e.message);
        },
        
        _displayAlertDialog: function(title, message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.setSecondaryTitle(title);
            alertDialog.open();
        },
        
        showRequirementList: function(){
            // If the project area is associated with a ReqPro project and no existing ReqPro requirement linking 
            // with the test case, then show the table tab control in the section.  Otherwise, only show 
            // the table containing the DOORS requirements.
            var self = this;
            
            var params = {
                rqmProjectItemId: getCurrentProjectArea().itemId,
                vtestCaseItemId: this.getArtifact().versionableItemId,
                isForTestPlan: false
            }
            
            var handler = {
                success: function(results) {
                    if (results == 0){
                        // no reqpro projects have been associated and no existing ReqPro requirement. Just show the Doors table.
                        self.currentTable = self.DOORS;
                        self._createDoorsTable();
                    }
                    else {
                        if (results == 2) {
                            self.reqProProjectLinked = false;
                        } else {
                            self.reqProProjectLinked = true;
                        }
                        // at least one reqpro project is associated or existing one ReqPro requirement at least. Show the table tab.
                        self._createTableTab();
                    }
                },
                error: function(e) {
                    self._error(e);
                }
            };
            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            RequirementItemClient.getIsShowingReqProTab(responseHandler, params);
        },
        
        _createReqProDialog: function(){
			this._createTableTab();
        },
        
        _createDoorsTable: function(){
            if(!this.tableDiv){
                this.tableDiv = document.createElement("div");
                this._tableContainer.appendChild(this.tableDiv);
            }
            this.showDoorsRequirementList();
        },
		
		_createTableTab: function(){
			
			if(!this.tableLinkDiv){
				this.tableLinkDiv = document.createElement("div");
				this.tableDiv = document.createElement("div");
				this._tableContainer.appendChild(document.createElement("br"));
				this._tableContainer.appendChild(this.tableLinkDiv);
				this._tableContainer.appendChild(this.tableDiv);
                this._constuctTableLinkBar();
				this._tableLinkOnClick(this.currentTable);
			}else if(this.currentTable == this.DOORS){
				this.showDoorsRequirementList();
			}else if(this.currentTable == this.REQPRO){
				this._reLoadReqProTable();
			}
		},
		
        _constuctTableLinkBar: function(){
            dojox.xml.parser.removeChildren(this.tableLinkDiv);
            
            var tableLinkTabsGroup = [];
            var count = this.requirementTables.length;
            var node = null;

            if (count == 1) {
                node = this._createTableText(this.requirementTables[i]);
                this.tableLinkDiv.appendChild(node);
            } else {
                for (var i = 0; i < count; i++) {
                    node = this._createTableLink(this.requirementTables[i], this.requirementTables[i] == this.currentTable, tableLinkTabsGroup);
                    this.tableLinkDiv.appendChild(node);
                }
            }
        },
        
        _createTableLink: function(tableName, isSelected, group){
            var aLink = new ViewHeaderLayout.InPageTabButton({
                label: Constants.getMessage(tableName),
                selected: isSelected,
                onSelect: dojo.hitch(this, "_tableLinkOnClick", tableName)
            })
            aLink.set('group', group);
            return aLink.domNode;
        },
        
        _createTableText: function(tableName){
        	var bNode = document.createElement("b");
            var tableLabel = Constants.getMessage(tableName);
            var textNode = document.createTextNode(tableLabel);
        	bNode.appendChild(textNode);
        	return bNode;
        },
        
        _tableLinkOnClick: function(tableName){
        	this.currentTable = tableName;
        	this._loadTable();
        },
        
        _reLoadReqProTable: function(){
        	
        	this.showLoadingReqProRequirementsMessage();

        	this._newAddedReqProRequirements = [];
        	this._removedReqProRequirements = [];
        	this._reqproItems = [];
        	
        	var params = {
				vtestCaseItemId: this.getArtifact().versionableItemId
			}
				
			var handler = {
						
				invoker: this,
					
				addRequirements: function(arg){
					if(arg){
									
						for(var i = 0;i < arg.length; i ++){
							arg[i].type = "requirement";
							arg[i].id = arg[i].itemId;
							
							if(!this.invoker.containsItemBasedOnItemId(this.invoker._reqproItems, arg[i].itemId)){
								this.invoker._reqproItems.push(arg[i]);
							}
						}
									
					}
					this.invoker.hideLoadingReqProRequirementsMessage();
					this.invoker._initalizeTableViewer(this.invoker._reqproItems);
					
				},
							
				error: function(e){
					this.invoker.hideLoadingReqProRequirementsMessage();
					alert("An error occurred: [" + e.message + "] @ reloadingrequirements");
					console.error(this.invoker.declaredClass + ": error: " + (e ? e.message : ""));  		
				}
			}
			var responseHandler = new ServiceResponseHandler(handler, "addRequirements", "error");
			//RequirementItemClient.getReqProRequirementsFromTestCase(responseHandler,params);
			setTimeout(dojo.hitch(RequirementItemClient, "getReqProRequirementsFromTestCase", responseHandler,params), 500);
        	
        },
        
        showLoadingReqProRequirementsMessage: function(){

        	if(this.reqproTable){
        		this.tableDiv.removeChild(this.reqproTable.domNode);
        	}else{        	
        		dojo.empty(this.tableDiv);
        	}
        	var loadingMessageDiv = document.createElement("div");
        	loadingMessageDiv.innerHTML = "<br><br>" + Constants.getMessage("labelLoadReqProRequirements");
        	this.tableDiv.appendChild(loadingMessageDiv);
        },
        
        hideLoadingReqProRequirementsMessage: function(){
        	dojo.empty(this.tableDiv);
        },
        
        _loadTable: function(){
        	
        	dojox.xml.parser.removeChildren(this.tableDiv);
        	
        	if(this.currentTable == this.REQPRO){
        		
        		if(this.reqproTable){
        			this.tableDiv.appendChild(this.reqproTable.domNode);
        		}else{
        			
            		if (this.getArtifact()) {
            			this._reLoadReqProTable();
          	  		}
            		else {
                		this._initalizeTableViewer([]);
            		}
        		}
            	
        		
        	}else{
        		
        		if(this.doorsTable){
        			this.tableDiv.appendChild(this.doorsTable.domNode);
        		}else{
					this.showDoorsRequirementList();
        		}

        	}

        },
        
        _initalizeTableViewer: function(items){
        	
        	if(this.currentTable == this.REQPRO){
        		
        		if (!this.reqproTable) {
                
                	this.reqproTable = new com.ibm.rqm.defects.web.ui.internal.ReqProLinksTableView({
                        tableId: this.tableId,
                		editable: this.isEditable(),
                    	printable: this.isPrintView(),
                    	enableRowSelection: true,
                   	 	actions: this.getTableActions(),
                   	 	isVirtualContent: false,
                   	 	showTypeColumn: false,
                   	 	allowSorting: true  // no server side paging so we can use client side sorting
                	});
        		}

                this.tableDiv.appendChild(this.reqproTable.domNode);
                
                //Disable add and reconcile buttons if no ReqPro project associated with the RQM project
                this.reqproTable.setActionByCheckingReqProProject(this.reqProProjectLinked);
                
                this.reqproTable.refresh(items);
                
            }	
            
        },

        associateSelectAllTableRequirements: function(selectAllTables, deselectedItems){
        	
        	var packageIds = [];
			var viewIds = [];
			var requirementKeys = [];
				
			for(var i = 0;i < selectAllTables.length;i ++){	
				var table = selectAllTables[i];
				if(table.type == "package"){
					packageIds.push(table.key);
				}else{
					viewIds.push(table.key);
				}
			}
			
			if(deselectedItems){
				for(var i = 0;i < deselectedItems.length; i ++){
					requirementKeys.push(deselectedItems[i].reqKey);
				}
			}

			var args = {
				viewIds: viewIds,
				packageIds: packageIds,
				serverItemId: this.currentReqProConnectionId,//this.requirementSourceSelectionDialog.currentReqProConnection.itemId,
				reqproProjectId: this.currentReqProProjectId,//this.requirementSourceSelectionDialog.currentReqProProjectId,
				isExclude: true,
				requirementKeys: requirementKeys
			}
	
			var responseHandler = new ServiceResponseHandler(this, "associateRequirementFinished", "_associateRequirementsError");         
            if(args.packageIds.length > 0){
            	this.requirementExplorer._showAssociationProcess();
            	RequirementItemClient.postPackageRequirements(responseHandler,args);
            }
            
            responseHandler = new ServiceResponseHandler(this, "associateRequirementFinished", "_associateRequirementsError");           
            if(args.viewIds.length > 0){
            	this.requirementExplorer._showAssociationProcess();
            	RequirementItemClient.postViewRequirements(responseHandler,args);
            }
        },
        
        associateIndividualRequirement: function(selectedItems){
        	
			var names = [];
			var descriptions = [];
			var keys = [];
			var versions = [];
			var srcIds = [];
			var suspectDateTimes = [];
			var guids = [];
			var tags = [];
				
			for(var i=0;i<selectedItems.length;i++){
					
				var requirement = selectedItems[i];
					
				names.push(requirement.name);
				if(requirement.description)
				{
					descriptions.push(requirement.description);
				}
				else
				{
					descriptions.push("");
				}
				keys.push(requirement.reqKey);
				versions.push(requirement.version);
				if(!requirement.suspectDateTime){
					suspectDateTimes.push(dojo.date.stamp.toISOString(new Date(0), {zulu: true}));
				}else{
					suspectDateTimes.push(requirement.suspectDateTime);
				}
				guids.push(requirement.guid);
					
				var srcId = "";
					
				if(this.currentReqProConnection.protocol == "http"){
					srcId = "reqpro/";
				}else{
					srcId = "reqprohttps/";
				}
					
				srcId += this.currentReqProConnection.hostname;
				srcId += ":";
				srcId += this.currentReqProConnection.port;
				srcId += "/";
				srcId += this.currentReqProProjectName;
				srcId += "/";
				srcId += requirement.reqKey;
				
				while(true){
					
					if(srcId.indexOf(" ") == -1)
						break;
						
					srcId = srcId.replace(" ", "%20");
					
				}
				
				srcIds.push(srcId);
				tags.push(requirement.tag);
			}
				
			var args = {
				names: dojo.toJson(names),
				descriptions: dojo.toJson(descriptions),
				keys: dojo.toJson(keys),
				versions: dojo.toJson(versions),
				srcIds: dojo.toJson(srcIds),
				suspectDateTimes: dojo.toJson(suspectDateTimes),
				guids: dojo.toJson(guids),
				tags: dojo.toJson(tags),
				reqProProjectItemId: this.currentReqProProjectId //this.requirementSourceSelectionDialog.currentReqProProjectId
			}
			
			this.requirementExplorer._showAssociationProcess();
				
			var responseHandler = new ServiceResponseHandler(this, "associateRequirementFinished", "_associateRequirementsError");
            RequirementItemClient.postRequirements(responseHandler,args);
        },
        
		onAssociateRequirement: function(selectedTreeNode, partialSelectedTreeNode, selectAllTables, partialSelectAllTables, deselectedItems, selectedItems, associateRequirementFromParentTestPlans){
			
			if(associateRequirementFromParentTestPlans == true){			
				this.floatingPane.close();
				this.requirementExplorer = this._createRequirementExplorer(null, null, null, null, true);
        		this._createFloatingPane(Constants.getMessage("associateRequirementDialogHead"), this.requirementExplorer.domNode, null, true);
				this.requirementExplorer.parentDialog = this.floatingPane;		
				this.requirementExplorer._showAssociationProcess();
				this.associateRequirementFinished(selectedItems);
				return;
			}
			
			if(!selectAllTables){
				selectAllTables = [];
			}
			
			if(!partialSelectAllTables){
				partialSelectAllTables = [];
			}
			
			if(!selectedItems){
				selectedItems = [];
			}
			
			selectAllTables = selectAllTables.concat(partialSelectAllTables);
			
			//handle select all situation
			if(selectAllTables.length > 0){
				this.associateSelectAllTableRequirements(selectAllTables, deselectedItems);
			}
			
			//handle single requirement selection situation
			if(selectedItems.length > 0){
				this.associateIndividualRequirement(selectedItems);
			}
						
        },
        
        addReqProSaveParticipantReferences: function(results, parentParticipant, isRemoved){
			
			var editor = this.getParentEditor();
			var context = editor.getSaveContext();
			
			for(var i=0;i<results.length;i++){
					
				var item = results[i];
					
				var participant = new com.ibm.rqm.requirement.web.ui.internal.view.requirement.ReqProSaveParticipant();
				participant.reqproItem = item;
				
				if(!isRemoved){	
					context.createReference(parentParticipant, "itemIds", participant);
				}else{
					context.removeReference(parentParticipant, "removedItemIds", item.itemId);
				}

			}
			
		},
		
		createReqProSaveParticipantReference: function(results, isRemoved){
			
			var editor = this.getParentEditor();
			var context = editor.getSaveContext();
			
			if(!this.reqproSaveParticipant){
					
				this.reqproSaveParticipant = new com.ibm.rqm.requirement.web.ui.internal.view.requirement.ReqProSaveParticipant();		
				context.addParticipant(this.reqproSaveParticipant);
				if (editor.isNew()){
					context.createReference(this.reqproSaveParticipant, this.REFERENCE_ID, editor);
				}else{
					this.reqproSaveParticipant.artifactItemId = this.getArtifact().versionableItemId;
				}	
				
				this.reqproSaveParticipant.itemType = "com.ibm.rqm.requirement.ReqProRequirement";		
				
			}
			
			this.addReqProSaveParticipantReferences(results, this.reqproSaveParticipant, isRemoved);

		},
		
		containsItemBasedOnItemId: function(array, targetId){
			
			if(!array){
				return false;
			}
			
			for(var step = 0;step < array.length;step ++){
				
				var item = array[step];
				if(item.itemId == targetId){
					return true;
				}
				
			}
			
			return false;
			
		},
		
		removeItemBasedOnItemIdFromArray: function(array, targetId){
			
			var result = [];
			
			if(!array){
				return array;
			}
			
			for(var step = 0;step < array.length;step ++){
				
				if(array[step].itemId == targetId){
					continue;
				}
				
				result.push(array[step]);
				
			}
			
			return result;
			
		},
        
        associateRequirementFinished: function(results){
        	
        	if(results){
        		for(var i = 0;i < results.length;i ++){
					if (!this.containsItemBasedOnItemId(this._reqproItems, results[i].itemId)) {
						results[i].type = "requirement";
						results[i].id = results[i].itemId;
						this._newAddedReqProRequirements.push(results[i]);
						this._reqproItems.push(results[i]);
					}
        			if(this.containsItemBasedOnItemId(this._removedReqProRequirements, results[i].itemId)){
        				var editor = this.getParentEditor();
						var context = editor.getSaveContext();
						context.unremoveReference(this.reqproSaveParticipant, "removedItemIds", results[i].itemId);
        				this._removedReqProRequirements = this.removeItemBasedOnItemIdFromArray(this._removedReqProRequirements, results[i].itemId);
        			}
        			
        			
        		}
        		
        		this.reqproTable.refresh(this._reqproItems);
        		this.createReqProSaveParticipantReference(results);
				this.setDirty();
        		
        	}
        	
        	this.requirementExplorer._endAssociationProcess();

        },
                
        _handleAssociateReqProRequirementClicked: function(){
        	
        	if(this.getArtifact() && this.getArtifactType() != Constants.TYPE_PLAN){
				
				var handler = {
					
					invoker: this,
					
					success: function(results){
						if(results && results.length > 0){
							this.invoker.hasParentTestPlans = true;
							this.invoker.createRequirementDialogBasedOnParentTestPlans(results);
						}else{
							this.invoker.hasParentTestPlans = false;
							this.invoker.noParentTestPlanDetected();
						}
					},
					
					error: function(e){
						alert("An error occurred: [" + e.message + "] @ Loading Parent Test Plan#_error");
						console.error(this.declaredClass + ": error: " + (e ? e.message : ""));  
					}
					
				}
				
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");
				PlanningClient.getRelatedTestPlanByCaseMinimalSummary(responseHandler, {uuid: this.getArtifact().versionableItemId, includeRetiredPlan: false});
        		
        		
        	}else{
        		this.noParentTestPlanDetected();
        	}
        	
        },
        
        findRequirementBasedOnParentTestPlans: function(responseHandler, args){
        	
        	var vtestPlanItemIds = [];
							
			for(var step = 0;step < this.currentParentTestPlans.length;step ++){
				vtestPlanItemIds.push(this.currentParentTestPlans[step].versionableItemId);
			}
							
			args.vtestPlanItemIds =  vtestPlanItemIds;
							
			RequirementItemClient.getReqProRequirementsFromTestPlans(responseHandler, args);
        	      	
        },
        
        handleFindRequirementBasedOnParentTestPlansResults: function(results){
        	
        	results.results = [];
        	for(var step = 0;step < results.length;step ++){
        		
        		var requirement = results[step];
        		requirement.type = "requirement";
        		requirement.id = requirement.srcId;
        		results.results.push(requirement);
        		
        	}
        	
        	
        },
        
        createRequirementDialogBasedOnParentTestPlans: function(results){


			this.currentParentTestPlans = results;

        	var descriptionDiv = document.createElement("div");
        	var tableDiv = document.createElement("div");
        	var actionBarDiv = document.createElement("div");
        	
        	var bodyDiv = document.createElement("div");
        	
        	var hr = document.createElement("hr");
        	hr.width = "100%";
        	hr.size = "1";
        	hr.color = "grey";
        	
        	bodyDiv.appendChild(descriptionDiv);
        	bodyDiv.appendChild(tableDiv);
        	bodyDiv.appendChild(hr);
        	bodyDiv.appendChild(actionBarDiv);
        	
        	this.associateButton = document.createElement("input");
        	this.associateButton.type = "button";
        	this.associateButton.value = Constants.getMessage("labelAssociateButton");
        	this.associateButton.disabled = true;
        	
        	
        	var cancelButton = document.createElement("input");
        	cancelButton.type = "button";
        	cancelButton.value = Constants.getMessage("labelCancelButton");
        	var self = this;
        	cancelButton.onclick = function(){self.floatingPane.close();};
        	
        	
        	actionBarDiv.style.textAlign = "right";
        	actionBarDiv.appendChild(this.associateButton);
        	actionBarDiv.appendChild(cancelButton);
        	
        	var bold = document.createElement("b");
        	var description = dojo.create("span", {innerHTML:Constants.getMessage("associateTestPlanRequirementDescription")}, bold);
        	var hereLink = null
            var childNodes = description.childNodes;
            
            if(childNodes){
            	for(var step = 0;step < childNodes.length;step ++){
            		if(childNodes[step].nodeType == 1){
            			hereLink = childNodes[step];
            			break;
            		}
            	}
            }
        	descriptionDiv.appendChild(bold);
        	
        	bodyDiv.style.margin = "20px 10px 10px 10px";
        	
        	
        	var args = {
	        	requirements: [],
	            editable: true,
	            isExternalByPriority: true,
	            hideResetButton: true,
	            showQueryFilters:true,
	            preDefinedSearchFun: dojo.hitch(this, "findRequirementBasedOnParentTestPlans"),
	            preDefinedSearchResultHandler: dojo.hitch(this, "handleFindRequirementBasedOnParentTestPlansResults"),
	            defaultIndividualSelectionStatus: true,
	            rowsCheckable: true,
	            operator: this,
	            isVirtualContent: false,
	            section:this,
	            showTypeColumn: false
	            //currentReqProConnection: this.currentReqProConnection
	        }
	         
			this.currentReqProTableView = new com.ibm.rqm.defects.web.ui.internal.ReqProLinksTableView(args);//new com.ibm.rqm.requirement.web.ui.internal.view.requirement.ReqProRequirementTableView(args)
        	
        	tableDiv.appendChild(this.currentReqProTableView.domNode);
        	
        	//this.currentReqProTableView.provider.loadPageContent([]);//results)
			
        	this._createFloatingPane(Constants.getMessage("associateTestPlanRequirementTitle"), bodyDiv, null, true);
        	
        	var self = this;
        	hereLink.onclick = function(){
        		self.floatingPane.close();
        		self.noParentTestPlanDetected();
        	}
        	
        	this.associateButton.onclick = function(){
        		var requirements = self.currentReqProTableView.getCheckedRows();
        		self.onAssociateRequirement(null, null, null, null, null, requirements, true);
        		self.floatingPane.close();
        	};
        	
        	this.currentReqProTableView.init();
        	
        }, 
        
        _notifySelectionChanged: function(){
        	if(this.currentReqProTableView.getCheckedRows().length > 0){
        		this.associateButton.disabled = false;
        	}else{
        		this.associateButton.disabled = true;
        	}
        },     
        
        noParentTestPlanDetected: function(){
        	this._loadReqProProjects();
        },
        
        parentTestPlanDetected: function(testPlans){
        	
        },
        
        _loadReqProProjects: function(){
        	var responseHandler = new ServiceResponseHandler(this, "_loadReqProProjectsFinished", "_error");
       		ReqProServerClient.getReqProProjectsInRQMProject(responseHandler, []);
        },
        
        _loadReqProProjectsFinished: function(results){
        	
        	var context = {
        		
        		invoker: this,
        		projects: results,
        		loadReqProConnectionsFinished: function(results){this.invoker._loadReqProConnectionsFinished(results, this.projects);},
        		_error: function(e){console.error("Load ReqPro projects faled");}
        		
        	};
        	
        	if(!results || results.length == 0){
        		var dlg = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({message:Constants.getMessage("labelNoAvailableReqProConnection")});
            	dlg.open();
        	}else{
        		var responseHandler = new ServiceResponseHandler(context, "loadReqProConnectionsFinished", "_error");
        		RequirementConnectClient.getReqProServersAssociatedProjectsAndProjArea(responseHandler, []);
        	}
        	
        },
        
        _loadReqProConnectionsFinished: function(connections, projects){
        	
        	if(!connections || connections.length == 0){
        		var dlg = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({message:Constants.getMessage("labelNoAvailableReqProConnection")});
            	dlg.open();
            	return;
        	}
        	
        	if(projects.length == 1){
        		
        		if(connections.length != 1){
        			console.error("There are multiple ReqPro connections that contain one same project.");
        		}
        		
        		this._createRequirementExplorerDirectly(connections[0], projects[0]);
        			
        	}else{
        		this._createSourceSelectionDialog(connections, projects);
        	}
        	
        	
        },
        
        
		_createRequirementExplorerDirectly: function(connection, project){
			
			this.currentReqProConnection = connection;
			this.currentReqProConnectionId = connection.itemId;
			this.currentReqProProjectId = project.itemId;
			this.currentReqProProjectName = project.name;
			
			this.requirementExplorer = this._createRequirementExplorer(this.currentReqProConnection, this.currentReqProProjectId);
        	this._createFloatingPane(Constants.getMessage("associateRequirementDialogHead"), this.requirementExplorer.domNode, null, true);
			this.requirementExplorer.parentDialog = this.floatingPane;

		},
		
		//Create source selection dialog, including ReqPro server and RRC server		
		_createSourceSelectionDialog: function(connections, projects){
			this._doCreateSourceSelectionDialog(connections, projects, [Constants.getMessage("labelReqPro"), Constants.getMessage("labelRRC")], Constants.getMessage("associateRequirementDialogHead"));
		},
		
		_createFloatingPane: function(dialogTitle, contentNode, yesCallBack, hideButtons){
			
			var args = {
                primaryTitle: dialogTitle,
                // make our z index below that of a popup tooltip. Otherwise,
                // our dialog will cover the tooltip popups
                zIndex: 998,
                forceZIndex: true,
                isClosable: true,
                contentNode: contentNode
            }
            
            if(yesCallBack){
            	args._yesAction = yesCallBack;
            }   
            
            this.floatingPane = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(args);
            
            if(hideButtons){
            	this.floatingPane._yesButton.style.display = "none";
            	this.floatingPane._noButton.style.display = "none";
            }else{
				this.floatingPane._yesButton.disabled = false;
            }
            dojox.xml.parser.removeChildren(this.floatingPane._headerText);
            var span1 = document.createElement("span");
            span1.innerHTML = dialogTitle;
            this.floatingPane._headerText.appendChild(span1);
            
            this.floatingPane.open(false);
            this.floatingPane.domNode.style.width = "70em";
			
		},
		
		
		_doCreateSourceSelectionDialog: function(connections, projects, sourceList, dialogTitle){
			
			this.requirementSourceSelectionDialog = new com.ibm.rqm.requirement.web.ui.internal.view.extension.RequirementAssociationSourceSelectionDialog({
				reqProConnections: connections,
				validatedProjects: projects,
				sourceList: sourceList
			});
			
			this._createFloatingPane(dialogTitle, this.requirementSourceSelectionDialog.domNode, dojo.hitch(this, "_handleOk"), false);
            
		},
				
		//When user clicks the "OK" button on the source selection dialog, decide which dialog will be poped up
        _handleOk: function(){
        	
        	this.currentReqProProjectId = this.requirementSourceSelectionDialog._getProjectSelection();
        	this.requirementSourceSelectionDialog.currentReqProProjectId = this.currentReqProProjectId;
        	this.currentReqProConnection = this.requirementSourceSelectionDialog.currentReqProConnection;
        	this.currentReqProConnectionId = this.currentReqProConnection.itemId;
        	this.currentReqProProjectName = this.requirementSourceSelectionDialog._getCurrentProjectName(this.currentReqProConnection.itemId, this.currentReqProProjectId);
        	this.requirementSourceSelectionDialog.currentReqProProjectName = this.currentReqProProjectName;

        	if(!this.currentReqProProjectId || this.currentReqProProjectId == ""){
        		this.floatingPane.close();
        		var dlg = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({message:Constants.getMessage("labelNoAvailableReqProProject")});
            	dlg.open();
        	}else{
				this.requirementExplorer = this._createRequirementExplorer(this.currentReqProConnection, this.currentReqProProjectId, this.floatingPane);
        		dojox.xml.parser.removeChildren(this.floatingPane.contentNode);
        		this.floatingPane.contentNode.appendChild(this.requirementExplorer.domNode);
        	}

        },
        
        _getSubTreeNodes: function(parentItem, onComplete){
			this.requirementExplorer._getSubTreeNodes(parentItem, onComplete, true);
		}, 
		
		openParentTestPlanRequirementList: function(){
			this.floatingPane.close();
			this._handleAssociateReqProRequirementClicked();
		},
		
		createTitleExtNode: function(){
			var titleExtNode = document.createElement("b");
        	titleExtNode.appendChild(document.createTextNode("("));
        	var linkNode = document.createElement("a");
        	linkNode.appendChild(document.createTextNode(Constants.getMessage("titleReturnToParentTestPlanRequirementList")));
        	linkNode.onclick = dojo.hitch(this, function(){
        		this.requirementExplorer._onCancel();
        		this._handleAssociateReqProRequirementClicked();
        	});
        	linkNode.style.cursor = "pointer";
        	titleExtNode.appendChild(linkNode);
        	titleExtNode.appendChild(document.createTextNode(")"));
        	return titleExtNode;
		},
                
        //If user selects ReqPro server as the source, create the ReqPro explorer dialog
        _createRequirementExplorer: function(reqProConnection, reqProProjectId, parentPane, reqproTypeFilters, onlyForAssocationProgress){
        	
        	return new com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementExplorer({
        			reqProConnection: reqProConnection,
        			reqProProjectId: reqProProjectId,
        			getChildrenFun: dojo.hitch(this, "_getSubTreeNodes"),
         			onSelectFun4Package: dojo.hitch(this, "_createPackageTable"),
    				onSelectFun4View: dojo.hitch(this, "_createViewTable"),
         			parentDialog: parentPane,
         			explorerTitle:Constants.getMessage("associateRequirementDialogTitle"),
         			isCheckboxTree: true,
         			onImportFun:dojo.hitch(this, "onAssociateRequirement"),
         			currentReqProConnection: this.currentReqProConnection,//this.requirementSourceSelectionDialog.currentReqProConnection,
         			currentReqProProject: this.currentReqProProjectName,//this.requirementSourceSelectionDialog.currentReqProName,
        	 		disableCheckboxTree: true,
        	 		reqproTypeFilters: reqproTypeFilters,
        	 		onlyForAssociationProgress: onlyForAssocationProgress,
        	 		titleExtension: (this.hasParentTestPlans && this.getArtifact() && this.getArtifactType() != Constants.TYPE_PLAN)?this.createTitleExtNode(): null
        	 });
        	
        },
        		
		_createViewTable: function(requirementViewId){
			
			var args = {
	            preDefinedSearchFun: dojo.hitch(this, "_getPagedRequirementsFromView"),
	            preDefinedSearchResultHandler: dojo.hitch(this, "_handleSearchResult"),
	            containerId: requirementViewId,
	            rowsCheckable: true,
	            isForView: true,
	            isVirtualContent: true,
	            showTypeColumn: false
	        }
			
			this.requirementExplorer._createRequirementTable(args);
			
		},
		
		_getPagedRequirementsFromView: function(responseHandler, args){
			
			args.serverItemId = this.requirementExplorer.reqProConnection.itemId;
			args.projectItemId = this.requirementExplorer.reqProProjectId;
			args.viewKey = this.requirementExplorer._getCurrentView();
			var pageOffset = this.requirementExplorer._getCurrentPageIndex() * this.requirementExplorer._getCurrentPageSize();
			args.pageOffset = pageOffset;//(pageOffset == 0)?1: pageOffset;
			args.page = this.requirementExplorer._getCurrentPageIndex();
			args.pageSize = this.requirementExplorer._getCurrentPageSize();
			
        	RequirementItemClient.getRequirementViewData(responseHandler, args);
		},
		
        _createPackageTable:function(requirementPackageId){
        	// If the ReqPro server doesn't support the Ping API, we just use the old apis to query single type.
        	if(this.currentReqProConnection.serverVersion == null || this.currentReqProConnection.serverVersion == "" ){
					
					var self = this;
					var args = {
						itemId: this.currentReqProConnection.itemId
					
					}
					var handler = {
						loadReqProConnectionFinished: function(results){
							self.currentReqProConnection = results;
							if (self.currentReqProConnection.serverVersion != null && self.currentReqProConnection.serverVersion == "Support_Ping_API"){
								
								var creationArgs = {
	            				preDefinedSearchFun: dojo.hitch(self, "_getPagedItems"),
	            				preDefinedSearchResultHandler: dojo.hitch(self, "_handleSearchResult"),
	            				containerId: requirementPackageId,
	            				rowsCheckable: true,
	            				isForView: false,
	            				isVirtualContent: true,
	            				showTypeColumn: false
        						};
        	
        						self.requirementExplorer._createRequirementTable(creationArgs);
								
							} 
							else{
								self._loadReqProTypeFilters(requirementPackageId);
								}
							},
        				_error: function(e){console.error("Load ReqPro server faled");}
					}
					
					var responseHandler = new ServiceResponseHandler(handler, "loadReqProConnectionFinished", "_error");
					
					ReqProServerClient.getReqProServer(responseHandler, args);
					
					
			} else {
				var self = this;
				if (self.currentReqProConnection.serverVersion == "Support_Ping_API"){
								
								var creationArgs = {
	            				preDefinedSearchFun: dojo.hitch(self, "_getPagedItems"),
	            				preDefinedSearchResultHandler: dojo.hitch(self, "_handleSearchResult"),
	            				containerId: requirementPackageId,
	            				rowsCheckable: true,
	            				isForView: false,
	            				isVirtualContent: true,
	            				showTypeColumn: false
        						};
        	
        						self.requirementExplorer._createRequirementTable(creationArgs);
								
					} 
				else{
						self._loadReqProTypeFilters(requirementPackageId);
					}
							
				
			}
        	
        },
        
        _loadReqProTypeFilters: function(requirementPackageId){
        	
        	if(!requirementPackageId){
        		requirementPackageId = 1;
        	}
        	
        	var args = {
        		
        		packageKey: requirementPackageId,
        		reqProProjectItemId: this.currentReqProProjectId,
        		connectionItemId: this.currentReqProConnectionId,
        		rqmProcssAreaId: getCurrentProjectArea().itemId

        	}

        	var context ={
        		
        		invoker: this,
        		
        		creationArgs: {
	            	preDefinedSearchFun: dojo.hitch(this, "_getPagedItems"),
	            	preDefinedSearchResultHandler: dojo.hitch(this, "_handleSearchResult"),
	            	containerId: requirementPackageId,
	            	rowsCheckable: true,
	            	isForView: false,
	            	isVirtualContent: true,
	            	showTypeColumn: false
        		},
        		
        		success: function(results){
        			this.creationArgs.typeFilters = results;
					this.invoker.requirementExplorer._createRequirementTable(this.creationArgs);
        		},
        		
        		error: function(e){
        			console.error("Loading reqpro type filters error.");
        		}
        	}
        	
        	var responseHandler = new ServiceResponseHandler(context, "success", "error");
		
			RequirementProjectClient.getReqProRequirementTypeFiltersWithRequirementNumber(responseHandler, args);
        	
        	
        },
        
        //When requirements are retrieved from backend server, the result DTO have to be handled to fit the requirement table view
        //Add two things: 1. The query status, 0 stands for query success
        //                2. The requirement table row's id, use reqKey for each returned requirement
        _handleSearchResult: function(resultsDTO){
        	
        	resultsDTO.status = 0;
        	var results = resultsDTO.results;
        	if(results){
        		
        		for(var i = 0;i < results.length; i ++){
        			var result=results[i];
        			result.id = result.reqKey;
        			result.type = "requirement";
        		}
        		
        		
        	}
        	
        	return resultsDTO;
        
        },
        
        //When user clicks "Next" or "Previouse" or other navigator button on requirement table view,
        //this method will be called to fetch the next page's requirements
		_getPagedItems: function(responseHandler, args){
			
			this._createQueryParams(args);
			
			
			
			var typeFilters = (this.requirementExplorer._getCurrentTypeFilters())?this.requirementExplorer._getCurrentTypeFilters().types:[];
			
			if(!typeFilters || typeFilters.length == 0){
				RequirementPackageClient.getPagedRequirements(responseHandler, args);
			}else{
				
				var realTypeFilters = this._calculateOffsetForTypeFilters(typeFilters, args.page, this.requirementExplorer._getCurrentPageSize());

				var totalContentCount = 0;
				
				for(var step = 0;step < realTypeFilters.length;step ++){
					totalContentCount += realTypeFilters[step].requirementNum;
				}
				
				this._getJointPagedItems(this.requirementExplorer._getCurrentTableView(), realTypeFilters, totalContentCount, args);
				
				
			}
	
		},
		
		_getJointPagedItems: function(table, typeFilters, totalContentCount, args){
			
			if(!typeFilters || typeFilters.length == 0){
				table._setCurrentPageIndex(0);
				table._setTotalContentCount(0);
				table._loadContent([]);
				return;
			}
			
			var context = {
				
				index: 0,
				results: [],
				args: args,
				parentTable: table,
				totalContentCount: totalContentCount,
				typeFilters: typeFilters,
				
				_getPagedItemsSuccess: function(results){
					
					if(results.results){
						
						var total = this.typeFilters[this.index].size;
						
						if(total == -1){
							total = results.results.length;
						}
						
						for(var step = 0;step < total;step ++){
							
							if(!results.results[step])
								break;
							//as in _handleSearchResult();							
							results.results[step].id = results.results[step].reqKey;
							results.results[step].type = "requirement";
							this.results.push(results.results[step]);
						}
					}
					
					this.index ++;
					if(this.index >= this.typeFilters.length){
						this.parentTable._setCurrentPageIndex(results.currentPage);
						this.parentTable._setTotalContentCount(this.totalContentCount);
						this.parentTable._loadContent(this.results);
					}else{
						this.args.type = this.typeFilters[this.index].typeName;
						var responseHandler = new ServiceResponseHandler(this, "_getPagedItemsSuccess", "_error");
						RequirementPackageClient.getPagedRequirements(responseHandler, this.args);
					}
					
				},
				_error: function(e){
					console.error("Get Joint Paged Requirement Items error.")
				}
					
			};

			args.pageOffset = typeFilters[0].pageOffset;
			args.type = typeFilters[0].typeName;
			
			var responseHandler = new ServiceResponseHandler(context, "_getPagedItemsSuccess", "_error");
			RequirementPackageClient.getPagedRequirements(responseHandler, args);
			
			
		},
		
		//This method is in charge of creating the args for fetching the next page's requirements
		_createQueryParams: function(args){
			
			args.connectionItemId = this.requirementExplorer.reqProConnection.itemId;
			args.projectItemId = this.requirementExplorer.reqProProjectId;
			args.packageKey = this.requirementExplorer._getCurrentRequirementFolder();
			args.pageOffset = this.requirementExplorer._getCurrentPageIndex() * this.requirementExplorer._getCurrentPageSize();
			args.page = this.requirementExplorer._getCurrentPageIndex();
			args.pageSize = this.requirementExplorer._getCurrentPageSize();

			return args;
		},
		
		_calculateOffsetForTypeFilters: function(typeFilters, page, pageSize){
			
			var requirementOffset = page * pageSize;
			
			if(!typeFilters || typeFilters.length == 0){
				return null;
			}
			
			var types = [];
			
			var cumulateOffset = requirementOffset;
			
			for(var step = 0;step < typeFilters.length;step ++){
				
				if(cumulateOffset < 0){
					cumulateOffset = 0;
				}
				
				var type = typeFilters[step];
				
				if(pageSize == -1){
					
					types.push({
						typeName: type.prefix,
						pageOffset: 0,
						size: pageSize,
						requirementNum: type.requirementNum 
					});
					
					continue;

				}
				
				
				
				if(type.requirementNum <= cumulateOffset){
					cumulateOffset -= type.requirementNum;
					continue;
				}else if(type.requirementNum - cumulateOffset >= pageSize){
					
					types.push({
						typeName: type.prefix,
						pageOffset: cumulateOffset,
						size: pageSize,
						requirementNum: type.requirementNum 
					});
					
					break;
				}else{
					
					types.push({
						typeName: type.prefix,
						pageOffset: cumulateOffset,
						size: type.requirementNum - cumulateOffset,
						requirementNum: type.requirementNum
					});
					
					pageSize -= (type.requirementNum - cumulateOffset)
					cumulateOffset -= (type.requirementNum - cumulateOffset);

				}
			}
			
			return types;
			
		},
        
		_error: function(e){
			alert("An error occurred: [" + e.message + "] @ Loading ReqPro Packages#_error");
			console.error(this.declaredClass + ": error: " + (e ? e.message : ""));  
		},
		
		_getSubViews: function(parentItem, onComplete){
			
			var args = {
				connectionItemId: this.requirementExplorer.reqProConnection.itemId,
				projectItemId: this.requirementExplorer.reqProProjectId
			}
		
			if(parentItem){
				args.packageKey = parentItem.type;
			}else{
				args.packageKey = "1";
			}
			
			args.key = "";
			
			var context = {
				onComplete: onComplete,
				invoker: this,
				parentItem: parentItem,
				_getSubViewsResult: this._getSubViewsResult,
				_error: this._error
			}

			var responseHandler = new ServiceResponseHandler(context, "_getSubViewsResult", "_error");
			RequirementPackageClient.getViews(responseHandler, args);
		},
		
		_getSubViewsResult: function(results){
			
			if(!results){
				
				
				//this.onComplete(this.parentItem.children);
				return;
			}
			
			for(var i=0;i<results.length;i++){
				
				var view = results[i];
				
				var item = this.invoker.requirementExplorer._createTreeNode({
			
					artifact: "2",
    				name: view.name,
    				type: view.viewKey
    				
				}, this.parentItem);
				
				
			}
			
			this.onComplete(this.parentItem.children);
			
		},
		
		removeReqProRequirementsOnUI: function(selectedRequirements){
			
			for(var i = 0;i < selectedRequirements.length;i ++){
				
				var requirement = selectedRequirements[i];
				
				if(this.containsItemBasedOnItemId(this._newAddedReqProRequirements, requirement.itemId)){
						
						var editor = this.getParentEditor();
						var context = editor.getSaveContext();
						context.uncreateReference(this.reqproSaveParticipant, "itemIds", requirement.itemId);
     
						this._newAddedReqProRequirements = this.removeItemBasedOnItemIdFromArray(this._newAddedReqProRequirements, requirement.itemId);

				}
				
				
				this._removedReqProRequirements.push(requirement);
			this.createReqProSaveParticipantReference([requirement], true);
				this._reqproItems = this._removeItemFromArrayBasedOnItemId(this._reqproItems, requirement.itemId);

			}
			
			this.reqproTable.refresh(this._reqproItems);
			
			
			if(selectedRequirements.length > 0){
				this.setDirty(true);
			}
			
		},
		
		_removeItemFromArrayBasedOnItemId: function(array, itemId){
            var updatedArray = [];
            for (var i = 0; i < array.length; i++) {
				if (array[i].itemId && array[i].itemId != itemId ) {
                    updatedArray.push(array[i]);
                }
            }
            return updatedArray;
        },
        
        _handleRefreshReqProLinksClicked: function(){
        	this._reLoadReqProTable();
        }

    });
    
})();
