/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.tests.mvvm.view.queryable.combo.QueryableComboViewTest");

dojo.require("com.ibm.team.dev.jdojo.junit.script.JSAssert");
dojo.require("com.ibm.team.rtc.foundation.api.common.Severity");
dojo.require("com.ibm.team.rtc.foundation.api.common.Status");
dojo.require("com.ibm.team.rtc.foundation.web.EventSource");
dojo.require("com.ibm.team.rtc.foundation.web.tests.EventRecorder");
dojo.require("com.ibm.team.workitem.web.mvvm.Util");
dojo.require("com.ibm.team.workitem.web.mvvm.view.queryable.combo.QueryableComboView");
dojo.require("com.ibm.team.workitem.web.tests.mvvm.view.queryable.combo.TestBase");

(function() {
var team= com.ibm.team;
var JSAssert= team.dev.jdojo.junit.script.JSAssert;
var foundation= team.rtc.foundation;
var common= foundation.api.common;
var Severity= common.Severity;
var Status= common.Status;
var web= foundation.web;
var EventSource= web.EventSource;
var EventRecorder= web.tests.EventRecorder;
var web2= team.workitem.web;
var mvvm= web2.mvvm;
var Util= mvvm.Util;
var QueryableComboView= mvvm.view.queryable.combo.QueryableComboView;
var TestBase= web2.tests.mvvm.view.queryable.combo.TestBase;

dojo.declare("com.ibm.team.workitem.web.tests.mvvm.view.queryable.combo.QueryableComboViewTest", TestBase, {

	//_testObj: null,

	setUp: function() {
		this._testObj= new QueryableComboViewTestClass({}, {});
	},

	testSpliceWithTwoEmptyArraysReturnsEmptyArray: function() {
		var actions= this.actions();
		var excluded= this.actions();
		var actual= this._testObj._splice(actions, excluded);
		JSAssert.assertEquals(0, actual.length);
	},

	testSpliceWithNoExcludedActionsReturnsAllActions: function() {
		var excluded= this.actions();
		var actions= this.actions("zip", "zap", "zup");
		var actual= this._testObj._splice(actions, excluded);
		this.assertSameActions(actions, actual);
	},

	testSpliceWithRemovesExcludedActionsAndReturnsRemainingActions: function() {
		var excluded= this.actions("zup", "zap");
		var actions= this.actions("zip", "zap", "zup");
		var actual= this._testObj._splice(actions, excluded);
		this.assertSameActions(actions, actual);
	},

	testSpliceWithRemovesNoActionsWithUnrelatedExcludedActions: function() {
		var excluded= this.actions("foo", "bar");
		var actions= this.actions("zip", "zap", "zup");
		var actual= this._testObj._splice(actions, excluded);
		this.assertSameActions(actions, actual);
	},

	testSetStatusWhenNotAllowAnyValueAndNonApplicableStatusDisplaysNonApplicableStatus: function() {
		this._testObj= new QueryableComboViewTestClass({allowAnyValue: false}, {});
		this._testObj.setStatus(Util.NONAPPLICABLE_VALUE_STATUS);
		JSAssert.assertEquals(Util.NONAPPLICABLE_VALUE_STATUS, this._testObj.getDisplayedStatus());
	},

	testSetStatusWhenAllowAnyValueAndNonApplicableStatusDisplaysOkStatus: function() {
		this._testObj= new QueryableComboViewTestClass({allowAnyValue: true}, {});
		this._testObj.setStatus(Util.NONAPPLICABLE_VALUE_STATUS);
		JSAssert.assertTrue(this._testObj.getDisplayedStatus().isOK());
	},

	testSetStatusWithOtherErrorsAreDisplayed: function() {
		this._testObj= new QueryableComboViewTestClass({allowAnyValue: true}, {});
		var otherErrorStatus= new Status(Severity.ERROR, "not good");
		this._testObj.setStatus(otherErrorStatus);
		JSAssert.assertEquals(otherErrorStatus, this._testObj.getDisplayedStatus());
	},

	testIsShownEventIsTriggeredOnExpandMenuCall: function() {
		var isShown= new EventSource();
		this._testObj= new QueryableComboViewTestClass({isShown: isShown}, {});
		var actions= this.actions("first", "second");
		this._testObj.setInput(actions[0], actions);
		var recorder= new EventRecorder().record(isShown);
		JSAssert.assertEquals(0, recorder.events.length);
		this._testObj.expandMenu(true);
		JSAssert.assertEquals(1, recorder.events.length);
	}
});
var QueryableComboViewTestClass= dojo.declare("com.ibm.team.workitem.web.tests.mvvm.view.queryable.combo.QueryableComboViewTest.QueryableComboViewTestClass", QueryableComboView, {

	constructor: function(params, domNode) {
	},

	_splice: function(actions, excludedActions) {
		return this.inherited("_splice", arguments, [actions, excludedActions]);
	}
});

})();
